;         EPROMMER5_asm                                     19.04.93 Jo
          errors    scr
          data      $11200

; V1d00   10.02.91
; V1d01   22.06.91 / V1e01 22.06.91
; V1d02   06.12.91 / V1e02 06.12.91
; V1d03   31.07.92         Marcel-Bug Zeile 180
; V1d04   22.09.92 / V1e04 GAL-A-Typen
; V1d05   19.04.93 / V1e04 jedtobin vor Prfen ausfhren

;basis     equ       $000CBFC0 ; Job-Version
;basis     equ       $00013FC0 ; Job-Version
basis     equ       $00003FC0 ; Eprom-Version
maxtyp    equ       6         ; 2764, 27128, 27256, 27512, GAL16V8, GAL20V8
; relativ (a6):
wmanv     equ       $0000
longint   equ       $0004
hexbuff   equ       $0008     ; 2 long
io_adr    equ       $0010     ; Karten-basis $C8000
startadr  equ       $0014     ; Startadresse im Eprom -> d7.l
endadr    equ       $0018     ; Endadresse im Eprom -> d6.l
fileadr   equ       $001C     ; Startadresse im File
hxstart   equ       $0020     ; Startadr als hexstring
hxend     equ       $0030     ; Endadr    "     "
hxfstart  equ       $0040     ; Startadr File   "
chid2     equ       $0050     ; CH-ID File LADEN, SICHERN
filen     equ       $0054     ; File-Lnge
maxadr    equ       $0058     ; Platz im Eprom $2000, $4000, $8000, $10000
; ------  Flags
tonflg    equ       $0060
typflg    equ       $0061     ; Eprom / GAL - Typ 1..6
fileflg   equ       $0062     ; gesetzt, wenn File zum Brennen ok
errflg    equ       $0063     ; gesetzt, wenn Fehlerschleife luft (in meldung)
gtojflg   equ       $0064     ; gesetzt, wenn GAL -> JEDEC Umwandlung gewhlt
doflg     equ       $0065     ; do oder hit auf apl.subwindow
aflg      equ       $0066     ; gesetzt wenn GAL-A-Typ
kennflg   equ       $0067     ; TEST: Kennung nicht auslesen vor brennen
dokflg    equ       $0068     ; TEST: Kennung nicht brennen
; frei
summe     equ       $0078     ; C-Prfsumme Jedec-File berechnet
psum      equ       $007C     ; C-Prfsumme Jedec-File original
; ------  Puffer
status    equ       $0080     ; $40+$20
wrkdef    equ       $00E0     ; bis $0BA8
status1   equ       $0BB0     ; Status Pulldown $60 max
wrkdef1   equ       $0C10     ; Working definition Pulldown $350 max
scontr    equ       $0F60     ; Scroll Controll 2 long
readbuff  equ       $0F68     ; $48 Lesepuffer Fileheader / Fehleranzeige
ladenam   equ       $0FB0     ; Filename LADEN $28
savenam   equ       $0FD8     ; Filename SICHERN $28
speicher  equ       $1000     ; 64 kbyte fr Eprom-Daten / JEDEC-File
galfile   equ       $3000     ; JEDEC-File binr oder GAL ausgelesen fr File
galdat    equ       $4000     ; Daten GAL ausgelesen zum Prfen
galpuff   equ       $5000     ; Puffer fr GAL Matrix spiegeln
galkennb  equ       $6000     ; GAL-Kennung binr
galkennh  equ       $6040     ; GAL-Kennung hex
; stack   equ      $11000     ; bis $11200

Jobheader
          bra.s     anfang
          dc.w      0
          dc.w      0
          dc.w      $4AFB
          dc.w      11          ;
          dc.b      'Eprommer II'   ;
          dc.b      '-1d05 Jo 1993 '   ; Version
          dc.b      '1904'              ; Datum

anfang
          lea       (a6,a4.l),a1
          movea.l   a1,a6               ; Data space
          clr.l     -(a7)
          moveq     #0,d0
/loop     move.l    d0,(a1)+            ; stack putzen
          cmp.l     a1,a7
            bgt.s   loop
          add.l     #4,a7
          moveq     #-1,d1              ; Job-ID
          moveq     #0,d3               ; open_old
          lea       con(pc),a0
          moveq     #1,d0
          trap      #2        ; IO_OPEN
          tst.l     d0
            bne.s   brakill
          moveq     #$70,d0
          moveq     #-1,d3
          trap      #3        ; IOP_PINF
          tst.l     d0                  ; ptr_gen da ?
            bne.s   repkill
          move.l    a1,d0               ; wman da ?
            beq.s   repkill
          movea.l   d0,a2               ; WMAN-Vector
          move.l    d0,wmanv(a6)        ; ..merken
          bra.s     setup

; Pointerumgebung fehlt
repkill   lea       ptrtxt(pc),a1
          move      SR,d7
          trap      #0
          suba.l    a0,a0
          moveq     #-1,d3
          movea.w   $D0,a2    ; UT_MTEXT
          jsr       (a2)
          move      d7,SR
brakill   bra       kill

; working definition anlegen
setup     moveq     #0,d1               ; default size
          lea       status(a6),a1
          lea       windef(pc),a3
          lea       wrkdef(a6),a4
          jsr       $04(a2)   ; WM_SETUP

; Defaults holen
          move.b    #3,typflg(a6)       ; 27256
          move.b    #$10,$40+23(a1)     ; NEIN
          move.b    #$10,$40+24(a1)     ; JA
          st        tonflg(a6)          ; Ton ein
; Eprom-Version
          lea       Jobheader(pc),a5    ; Eprom-Version
          move.l    a5,d0
          andi.w    #$C000,d0           ; Karten-adresse $10000 oder $C8000
          add.l     #basis,d0           ; + $3FC0
; Job-Version
;          move.l    #basis,d0           ; Job-Version $13fc0 oder $cdfc0
;   ---
          move.l    d0,io_adr(a6)       ; MC6821 io-adressen
          bsr       ini                 ; Karte initialisieren

; position primary window, cls, draw
          moveq     #-1,d1
          move.b    fendef(pc),d0
            bne.s   patp
          move.l    xodef(pc),d1        ; Voreinstellung wd_xorg,wd_yorg
patp      jsr       $0C(a2)   ; WM_PRPOS
;          jsr       $1C(a2)   ; WM_WDRAW  ; malt  ALLE Info-Fenster !
          moveq     #-1,d3
          move.w    #%1111110000000000,d3  ; nur Info-Fenster 0..9 malen
          jsr       $3C(a2)   ; WM_IDRAW
          moveq     #0,d3                  ; alle Loose menu items malen
          jsr       $2C(a2)   ; WM_LDRAW
          lea       scontr(a6),a1
          addq.w    #1,(a1)+             ; 1 Scrollfenster
          clr.l     (a1)+
          move.w    #$40,(a1)
; Default-typ anzeigen
          bsr       typini

; read pointer loop
rptr
/loop     movea.l   (a4),a1   ; status
          jsr       $30(a2)   ; WM_RPTR
          tst.l     d0                  ; war weg ???
            bmi.s   kill                ; QDOS-Fehler
          btst      #$15,$15(a1)        ; sleep
            bne.s   dosleep
          btst      #$11,$15(a1)        ; cancel
            bne.s   kill
          btst      #$12,$15(a1)        ; help
            beq.s   schiebe
          bsr       AINFO
          bra.s     loop
schiebe   btst      #$13,$15(a1)        ; move
            bne.s   movewin
          bra.s     loop
movewin   jsr       $40(a2)   ; WM_CHWIN
          move.b    #1,$40(a1)          ; status redraw item 0
ldraw     moveq     #-1,d3              ; draw selectiv
          jsr       $2C(a2)   ; WM_LDRAW
          bra.s     loop
kill
          movea.l   io_adr(a6),a5
          moveq     #0,d3
          move.l    d3,4(a5)            ; Ucc aus
          move.l    d3,(a5)             ; alle Pins auf 0
          move.l    d0,d3
          moveq     #-1,d1
          moveq     #5,d0
          trap      #1        ; MT_FRJOB
          moveq     #0,d0
          rts                 ; falls ge'CALL't

; sleep event, Job zum Button schrumpfen, falls QPAC2 vorhanden
dosleep
          bsr       uccaus
          bsr.s     fthing
            bne.s   slerr
          moveq     #0,d6
/loop     movem.l   d1-d2/a0-a1,-(a7)
          moveq     #-1,d1              ; Job-ID
          moveq     #$7F,d2
          swap      d2                  ; priority / timeout
          lea       thgnamed(pc),a0     ; 'Button_Schlaf'
          adda.w    d6,a0               ; oder 'Button_sleep'
          jsr       (a5)                ; TH_EXEC
          movem.l   (a7)+,d1-d2/a0-a1
          tst.l     d0
            beq.s   slexit
          tst.w     d6
            bne.s   slerr
          moveq     #thgnamee-thgnamed,d6
          bra.s     loop
slexit    bset      #3,d0               ; item 3 sleep
          bsr       clrloose
          bsr.s     noevent
          bra       rptr
slerr     moveq     #0,d0
          bset      #16,d0              ; trt
          bsr       ton
          moveq     #0,d0     ; Marcel-Bug item 16 anwhlen weg
          bra.s     slexit

; find thing-vector, TH_EXEC -> a5
fthing    movem.l   d1-d2/d7/a0,-(a7)
          move      SR,d7
          trap      #0
          moveq     #0,d0
          trap      #1
          move.l    $B8(a0),d0          ; SV_THING
            beq.s   thgnf               ; nicht da
/loop     movea.l   d0,a0
          move.l    (a0),d0
            bne.s   loop                ; letztes Thing ?
          movea.l   $10(a0),a0          ; TH_THING
          cmpi.l    #'THG%',(a0)+       ; TH_FLAG
            bne.s   thgnf
          moveq     #1,d0
          add.l     (a0)+,d0            ; TH_TYPE -1
            bne.s   thgnf
          movea.l   4(a0),a5            ; TH_EXEC
          moveq     #0,d0               ; ok
thgexit   move      d7,SR
          movem.l   (a7)+,d1-d2/d7/a0
          tst.l     d0
          rts
thgnf     moveq     #-7,d0              ; ERR_NF
          bra.s     thgexit

; window event action routines
noevent   moveq     #0,d4
          bra.s     okrts
sleep     moveq     #$15,d4
          bra.s     lrts
move      moveq     #$13,d4
          bra.s     lrts
esc       moveq     #$11,d4
okrts
lrts      moveq     #0,d0
          rts

; Typen-Auswahl
typini
          moveq     #0,d0
          moveq     #0,d1
          move.b    typflg(a6),d1
          addq.w    #3,d1
          bset      d1,d0
          bsr       setsel
          lea       setunavl(pc),a1
          cmpi.b    #7,d1
            ble.s   typinial
          lea       clrloose(pc),a1
          bra.s     typinial
e2764
e27128
e27256
e27512    lea       setunavl(pc),a1
          bra.s     clrtyp
g16v8
g20v8     lea       clrloose(pc),a1
clrtyp    bsr       uccaus
          move.w    $10(a3),d1
typinial
          moveq     #0,d0
          bset      #14,d0              ; LSCHEN
          bset      #17,d0              ; SCHTZEN
          jsr       (a1)
          move.l    #%1111110000,d0     ; item Nr 4..9
          bclr      d1,d0
          subq.w    #3,d1
          move.b    d1,typflg(a6)       ; typ 1..6
          bsr       clrloose
          bsr       chgdil              ; Sockel+Beschriftung anzeigen
          cmpi.b    #4,d1
            ble.s   setadr
; GAL Grundeinstellung
          move.l    #%11010000000000000,d0  ; Nr 16,15,13 Adressen
          bsr       setunavl
          moveq     #0,d0
          bset      #12,d0              ; LEERTEST selected
          bset      #14,d0              ; LSCHEN  selected
          bset      #19,d0              ; PRFEN   selected
          bsr       setsel
          moveq     #0,d7     ; ERR_ok
          move.l    d7,maxadr(a6)       ; GAL: maxadr=0
          bra.s     typex
; EPROMs Grundeinstellung
setadr    moveq     #2,d0
          lsl.w     d1,d0
          move.l    d0,d1
          moveq     #11,d0
          lsl.l     d0,d1
          subq.l    #1,d1               ; 1 $1FFF, 2 $3FFF, 3 $7FFF, 4 $FFFF
          move.l    d1,maxadr(a6)
zeigeadr
          move.l    filen(a6),d0
            beq.s   flen0
          subq.l    #1,d0               ; d0.l Endadresse
          cmp.l     d1,d0
            ble.s   filpasst
          moveq     #10,d7              ; 'WARNUNG! File passt nicht ins Eprom'
          bset      #17,d7
          bra.s     flen0
filpasst  move.l    d0,d1
          moveq     #0,d7     ; ERR_ok
flen0     move.l    d1,endadr(a6)
          move.l    d1,longint(a6)
          moveq     #4,d4
          lea       hxend(a6),a1
          move.w    d4,(a1)+
          bsr       lintoas4
          moveq     #0,d1
          move.l    d1,startadr(a6)
          move.l    d1,fileadr(a6)
          move.l    d1,longint(a6)
          lea       hxstart(a6),a1
          move.w    d4,(a1)+
          bsr       lintoas4
          lea       hxfstart(a6),a1
          move.w    d4,(a1)+
          bsr       lintoas4
          bsr       showadr
typex     bsr       gettyple            ; GAL-LED ein/aus
          move.l    d7,d0
          bsr       errorld
          sf        errflg(a6)
          moveq     #0,d4
          moveq     #2,d0               ; nein
          rts

; Action-routine Nr 10  EPROM / GAL auslesen
auslesen
          tst.b     fileflg(a6)
            beq.s   ausles1
          moveq     #20,d0
          bset      #17,d0              ; 'WARNUNG ! File wird berschrieben'
          bsr       errorld
          lea       nultxt(pc),a5
          bsr       janein
            bne.s   lesexit
ausles1   st        fileflg(a6)
          sf        errflg(a6)
          moveq     #5,d0               ; 'GAL / EPROM auslesen'
          bset      #17,d0              ; klick
          bsr       errorld
          move.b    typflg(a6),d0
          cmpi.b    #4,d0
            bgt.s   gausles
          lea       speicher(a6),a1
          move.l    endadr(a6),d6
          move.l    startadr(a6),d7
          move.l    d6,d0
          sub.l     d7,d0
          addq.l    #1,d0
          move.l    d0,filen(a6)
          bsr       eprlesen
          lea       eprtxt(pc),a5
lesexit   bsr.s     cegtxt
          moveq     #10,d4
          bra       anzexit
gausles   bsr       galausl
          move.b    #1,fileflg(a6)      ; Flag JEDEC
          lea       galtxt(pc),a5
          bra.s     lesexit
cegtxt
          lea       ladenam(a6),a1
          moveq     #20,d1
          jsr       $4C(a2)   ; WM_STLOB
          move.w    (a5)+,d0
            beq.s   cegdbf
          move.w    d0,(a1)+
          bra.s     cegdbf
/loop     move.b    (a5)+,(a1)+
cegdbf    dbf       d0,loop
          moveq     #0,d0
          bset      d1,d0
          bsr       clrloose
          rts

; Action Routine Nr 12, LEERTEST
leertest
          cmpi.w    #2,d2               ; do?
            bne     noevent             ; ..nein
leertst1  sf        errflg(a6)
/loop     cmpi.b    #4,typflg(a6)
            bgt.s   galleer
          bsr       getadr
          bsr       eprleer
            beq.s   leerok
          bra.s     nleer
galleer   bsr       galtest
            beq.s   leerok
nleer     bsr       meldung             ; hier wird errflg=true gesetzt
          bsr       janein
            beq.s   loop
nlmeld    moveq     #12,d0              ; 'GAL / EPROM nicht leer'
          bset      #17,d0
          bra.s     leer1
leerok    tst.b     errflg(a6)
            bne.s   nlmeld
          moveq     #11,d0              ; 'GAL / EPROM leer'
leer1     moveq     #12,d4
          bra       anzexit

; Action routine BRENNEN Nr 18
brenn
;-          cmpi.w    #2,d2               ; do?
;-            bne     nein
          tst.b     fileflg(a6)
            beq.s   brerr3              ; kein file geladen
          moveq     #19,d0              ; 'Alle Einstellungen berprft?'
          bset      #17,d0
          bsr       errorld
          bsr       janein
            bne.s   brexit
          cmpi.b    #4,typflg(a6)
            bgt.s   brgal
; ----------------- EPROM's brennen
          btst      #7,status+$40+12(a6) ; LEERTEST selected?
            beq.s   nixltest
          bsr.s     leertst1
          moveq     #12,d0              ; 'GAL/EPROM nicht leer'
          tst.b     errflg(a6)
            bne.s   brexit
nixltest
          sf        errflg(a6)
/loop     moveq     #6,d0               ; 'EPROM brennen ..'
          bset      #17,d0              ; klick
          bsr       errorld
          bsr     getadr
          bsr       brennen
            beq.s   brepruef
          bsr       meldung
          bsr       janein
            beq.s   loop
brefehl   moveq     #17,d0              ; 'GAL/EPROM fehlerhaft'
          bra.s     brexit
brepruef
          btst      #7,status+$40+19(a6) ; PRFEN selected?
            bne.s   dopruef             ; ..ja
          tst.b     errflg(a6)
            bne.s   brefehl
          bra.s     brexit
dopruef   bsr     pruef1
          bra.s     brexit
brerr3    moveq     #3,d0               ; 'keine Datei geladen'
          bset      #16,d0              ; trt
brexit    moveq     #18,d4
          bra       anzexit
; ----------------- GAL's brennen
brgal
          tst.b     fileflg(a6)
            bgt.s   gleertst
          moveq     #9,d0               ; 'kein gltiger Jedec-File'
          bset      #16,d0
          bra.s     brexit
gleertst
          btst      #7,status+$40+12(a6) ; LEERTEST selected?
            beq.s   glschtst            ; ..nein, evtl. lschen ?
          bsr       leertst1
          tst.b     errflg(a6)
            beq.s   gbrenn              ; GAL ist leer
          btst      #7,status+$40+14(a6) ; LSCHEN selected ?
            beq.s   leernc              ; ..nein, abbrechen
          moveq     #15,d0              ; "GAL wirklich lschen ? [J/N]"
          bsr       errorld
          bsr       janein              ; JA / NEIN ?
            beq.s   doloesch            ; ..ja
leernc    moveq     #12,d0              ; "GAL / EPROM nicht leer"
          bra.s     brexit
glschtst
          btst      #7,status+$40+14(a6) ; LSCHEN selected ?
            beq.s   gbrenn
doloesch  bsr       loesch1
          move.l    zeitk(pc),d0
          mulu      #1000,d0            ; 1000 * 0.1 ms = 100 ms
/loop     subq.l    #1,d0               ; ..warten
            bgt.s   loop
gbrenn
          sf        errflg(a6)
          move.b    aflg(a6),d6
          bsr       kennlesen           ; Kennung auslesen, aflg setzen
            beq.s   kennok
          move.b    d0,errflg(a6)       ; d0=24: 'GAL-Typ unbekannt'
          bset      #16,d0              ; trt
          bra.s     brexit
kennok    cmp.b     aflg(a6),d6
            beq.s   altles

          movem.l   d0-d7/a0-a5,-(a7)
          bsr       jedtobin            ; JEDEC nochmal umwandeln (ACW ndern)
          movem.l   (a7)+,d0-d7/a0-a5
altles
          bsr       galbrenn            ; GAL brennen
          bsr       brepruef
          btst      #7,status+$40+17(a6) ; Schtzen selected ?
            beq.s   schok
          bsr       seccell1
schok     moveq     #0,d0
          rts

; Adresse zum Brennen setzen
getadr
          move.l    endadr(a6),d6
          tst.b     errflg(a6)
            bne.s   getrts
          move.l    startadr(a6),d7
          move.l    fileadr(a6),d0
          lea       speicher(a6),a1
          adda.l    d0,a1
getrts    rts

; Action routine PRFEN Nr 19
pruef
          cmpi.w    #2,d2
            bne     noevent
pruef1    sf        errflg(a6)
/loop     moveq     #8,d0               ; 'GAL / EPROM Prflesen..'
          bsr       errorld
          cmpi.b    #4,typflg(a6)
            bgt.s   pruefgal
          bsr.s     getadr
          bsr       eprpruef            ; EPROM mit File vergleichen
          bra.s     pruefex
pruefgal  tst.b     fileflg(a6)
            bgt.s   galcmp
          moveq     #9,d0               ; 'kein gltiger JEDEC-File'
          bra.s     prueferr
galcmp    bsr       galcomp             ; GAL -> galdat mit galfile vergleichen
pruefex     beq.s   pruefok
          bsr       meldung
          bsr       janein
            beq.s   loop
prseterr  moveq     #17,d0              ; 'GAL/EPROM fehlerhaft'
prueferr  bset      #16,d0              ; trt
          bra.s     prex19
pruefok   tst.b     errflg(a6)
            bne.s   prseterr
prex19    moveq     #19,d4
          bra       anzexit


; Action routine LSCHEN Nr 14, nur fr GAL's
loesch
          cmpi.w    #2,d2               ; do ?
            bne     noevent             ; ..nein, nur hit, anwhlen
          moveq     #14,d4
          moveq     #15,d0              ; 'GAL wirklich lschen?'
          bset      #17,d0
          bsr       errorld
          bsr.s     janein
            bne.s   nex
loesch1   move      SR,d4
          trap      #0                  ; supervisor
          ori       #$0700,SR
          bsr       gettyple            ; Steuerbyte -> d5.w, a5,a3 setzen
          bsr       eprein              ; GAL-EDIT-modus einschalten, 10 ms
          bsr       galclr              ; GAL lschen, bulk erase 50 ms
          move      d4,SR               ; usermodus
          moveq     #14,d4
          moveq     #7,d0               ; "GAL gelscht"
          bra.s     anzexit

; Action Routine Nr 17, SICHERN, nur fr GAL's
seccell
          cmpi.w    #2,d2               ; do?
            bne     noevent             ; ..nein
          moveq     #17,d4
          moveq     #13,d0              ; 'GAL-Lesesicherung setzen?'
          bset      #17,d0
          bsr       errorld
          bsr.s     janein
            bne.s   nex
seccell1  move      SR,d4
          trap      #0                  ; supervisor
          ori       #$0700,SR
          bsr       gettyple            ; Steuerbyte -> d5.w, a5,a3 setzen
          bsr       eprein              ; GAL-EDIT-modus einschalten, 10 ms
          bsr       brenn61             ; GAL sichern, Reihe 61
          move      d4,SR               ; usermodus
          moveq     #17,d4
          moveq     #14,d0              ; 'GAL-Lesesicherung gesetzt !'
          bra.s     anzexit
nex       moveq     #0,d0
          bra.s     anzexit

; Frage abwarten
janein
          moveq     #0,d0
          bset      #23,d0
          bset      #24,d0
          bsr       clrloose
;          move.l    #$01D800D0,d1       ; x,y
;          moveq     #-1,d2              ; rel window definition
;          moveq     #-1,d3              ; timeout
;          moveq     #$7B,d0
;          trap      #3
          jsr       $30(a2)   ; WM_RPTR
          move.l    d0,d1
          moveq     #0,d0
          bset      #23,d0
          bset      #24,d0
          bsr       setunavl
          subq.l    #1,d1               ; d1=1 ja, d1=2 nein
          rts                           ; ja: cond.code Z, nein: cond.code neg

; Action Routine JA
ja
          moveq     #0,d0
          bset      #24,d0
          bsr       clrloose
          moveq     #0,d4
          moveq     #1,d0
          rts
; Anzeige Meldung / Fehler d0.l
anzexit   move.l    d0,d7
          bsr       errorld
          moveq     #0,d0
          bset      d4,d0
          bsr       clrloose
          bsr.s     uccaus              ; nach Aktion: Ucc aus; d0 = 0
          moveq     #0,d4               ; no action
          move.l    d7,d0               ; Meldung oder Fehler Anzeige
          rts

; Action Routine NEIN
nein
          moveq     #0,d4
          moveq     #2,d0
          rts

; Action routine Ucc Nr 22
ucc
          move.w    $10(a3),d1
          btst      #7,$40(a1,d1.w)
            beq.s   uccaus
          bsr       gettyple
          bsr       eprein
          bra.s     uccok
uccaus    movea.l   io_adr(a6),a5
          moveq     #0,d0
          move.b    #$34,7(a5)          ; Ucc/Upp aus
          move.l    d0,(a5)             ; alle Pins auf 0
          bset      #22,d0
          bsr       clrloose            ; Ucc aus anzeigen
uccok     moveq     #0,d0
          rts
; ---------------------------------------
; Action Routinen 13 Start Eprom, 15 Ende Eprom, 16 Start File
sepr
          lea       hxstart(a6),a1
          lea       startadr(a6),a5
          bra.s     hexinput
eepr
          lea       hxend(a6),a1
          lea       endadr(a6),a5
          bra.s     hexinput
sfile
          lea       hxfstart(a6),a1
          lea       fileadr(a6),a5
hexinput
          move.l    (a5),d5             ; Adresse retten, falls Fehler
          move.l    a1,d3
          move.w    $10(a3),d1
          move.w    d1,d6               ; Item nr 13, 15 oder 16
          moveq     #0,d2
          jsr       $5C(a2)   ; WM_SWLIT
          movea.l   d3,a1
          jsr       $68(a2)   ; WM_RNAME
            bmi.s   hxerr
            bgt.s   hxok
          move.w    (a1),d0             ; Lnge string
            beq.s   hxok
          moveq     #4,d1
          move.w    d1,(a1)+            ; d1.w 4 bytes
          bsr       hextolint           ; a1 hexascii -> a5 longinteger
            beq.s   hxrts
          move.l    d5,(a5)
hxrts     move.l    (a5),longint(a6)
          bsr       lintoas4
          cmpi.w    #15,d6              ; bei endadr weiter
            beq.s   tstadr              ; .. sonst endadr neu berechnen
          move.l    filen(a6),d0
          sub.l     fileadr(a6),d0
          add.l     startadr(a6),d0
          move.l    d0,endadr(a6)
          lea       hxend+2(a6),a1
          move.l    d0,longint(a6)
          bsr       lintoas4
tstadr    bsr.s     testadr
          bsr       errorld
hxok      bsr       showadr
          moveq     #0,d0
hxerr     rts

; startadr, endadr, fileadr, maxadr, filen auf Logig testen
testadr
          moveq     #22,d0              ; 'Endadresse passt nicht in's Eprom'
          move.l    endadr(a6),d1
          cmp.l     maxadr(a6),d1
            bgt.s   testerr
          moveq     #1,d0               ; 'Startadresse >= Endadresse'
          cmp.l     startadr(a6),d1
            ble.s   testerr
          moveq     #23,d0              ; 'Start im File > Filelnge'
          move.l    filen(a6),d3
          subq.l    #1,d3
          sub.l     fileadr(a6),d3
            bmi.s   testerr
          moveq     #10,d0            ; 'WARNUNG! File passt nicht in das Eprom'
          add.l     startadr(a6),d3
          cmp.l     maxadr(a6),d3
            bgt.s   testerr
          moveq     #0,d0
          rts
testerr   bset      #17,d0              ; klick
          tst.l     d0
          rts

; ---------------------------------------
; LADEN: action routine 20
lade
          tst.b     fileflg(a6)
            beq.s   lade1
          moveq     #20,d0              ; 'WARNUNG ! File wird berschrieben'
          bset      #17,d0
          bsr       errorld
          bsr       janein
            bne     filrts
lade1     move.w    $10(a3),d1          ; item number
          moveq     #0,d2
          jsr       $5C(a2)   ; WM_SWLIT
          lea       ladenam(a6),a1
          jsr       $4C(a2)   ; WM_STLOB
          jsr       $68(a2)   ; WM_RNAME
            bmi     filerr              ; qdos-fehler
            bgt.s   filrts              ; up, down, esc
          tst.w     (a1)                ; enter
            beq     file0               ; stringlnge=0, kein File geladen
          bsr       open_in
            bne.s   filerr
          bsr       headr
            bne.s   filerrcl
          move.l    readbuff(a6),d1     ; Filelnge ( fsload )
          moveq     #2,d0               ; 'File zu gro'
          bset      #16,d0
          move.l    #$10000,d5          ; max Filelnge
          move.b    typflg(a6),d2
          cmpi.b    #4,d2
            ble.s   eprfgr
          lsr.l     #3,d5               ; /8 = $2000 fr JEDEC-File
eprfgr    cmp.l     d5,d1
            bgt.s   filerrcl
          lea       speicher(a6),a5
          move.w    #$3FFF,d0           ; 4*$4000 = $10000 mit $FF belegen
          moveq     #-1,d5
/loop     move.l    d5,(a5)+
          dbf       d0,loop
          sf        fileflg(a6)
          bsr       fsload
          bsr       close2
            bne.s   filerr
          move.l    d1,filen(a6)        ; File-Lnge
          cmpi.b    #4,d2
            bgt.s   galconv
          bsr       zeigeadr            ; d1.l -> endadr(a6), 0->start
          st        fileflg(a6)
          bsr       testadr
          bra.s     filerr
galconv
          bsr       jedtobin
            beq.s   jedok
          cmpi.w    #21,d0
            bne.s   filerr
jedok     move.b    #1,fileflg(a6)      ; Flag JEDEC
          bra.s     filerr

filrts    moveq     #0,d0
          bra.s     filerr
filerrcl  bsr       close2
filerr    bsr       errorld             ; wmanv(a6) -> a2
errexit   moveq     #0,d0
          bset      #20,d0
          bset      #21,d0
          bsr       clrloose
          moveq     #0,d0
          rts
file0     sf        fileflg(a6)
          clr.l     filen(a6)
          moveq     #0,d1
          move.b    typflg(a6),d1
          cmpi.b    #4,d1
            bgt.s   filrts
          bsr       setadr
          bra.s     filrts

; Action Routine Nr 21 Datei SICHERN:
sich
          tst.b     fileflg(a6)
            bne.s   sfilgel
          moveq     #3,d0               ; 'keine Datei geladen'
          bset      #17,d0
          bra       filerr
sfilgel   move.w    $10(a3),d1          ; item number
          moveq     #0,d2
          jsr       $5C(a2)   ; WM_SWLIT
          lea       savenam(a6),a1
          jsr       $4C(a2)   ; WM_STLOB
          jsr       $68(a2)   ; WM_RNAME
            bmi     filerr
            bgt     filrts
          tst.w     (a1)
            beq     filrts
          bsr.s     open_new
            beq.s   sfilgef
          cmpi.w    #-8,d0    ; ERR_EX
            bne     filerr
          moveq     #4,d0               ; 'gibt es schon, berschreiben? J/N'
          bset      #17,d0              ; klick
          bsr       errorld
          bsr       janein
            beq.s   fsaveok
          bra       filrts
fsaveok   bsr.s     open_over
            bne     filerr
sfilgef   bsr.s     fssave
          bra       filerrcl

; OPEN-Traps
open_in
          moveq     #1,d3
          bra.s     open_a
open_new
          moveq     #2,d3
          bra.s     open_a
open_over
          moveq     #3,d3
open_a    movem.l   d1-d2/a0-a1,-(a7)
          moveq     #-1,d1              ; jobid dieser Job
          movea.l   a1,a0               ; Zeiger auf Filename
          moveq     #1,d0
          trap      #2        ; IO_OPEN
          move.l    a0,chid2(a6)
          movem.l   (a7)+,d1-d2/a0-a1
gepatcht  tst.l     d0
          rts

; Fileheader lesen -> readbuff(a6)
headr
          movem.l   d1-d3/a0-a1,-(a7)
          moveq     #$0E,d2
          moveq     #-1,d3
          movea.l   chid2(a6),a0
          lea       readbuff(a6),a1
          moveq     #$47,d0             ; FS_HEADR
          trap      #3
          movem.l   (a7)+,d1-d3/a0-a1
          tst.l     d0
          rts

; File laden -> speicher(a6)
fsload
          movem.l   d1-d3/a0-a1,-(a7)
          move.l    d1,d2
          moveq     #-1,d3
          movea.l   chid2(a6),a0
          lea       speicher(a6),a1
          moveq     #$48,d0
          trap      #3        ; FS_LOAD
          movem.l   (a7)+,d1-d3/a0-a1
          tst.l     d0
          rts

; Speicher sichern -> File
fssave
          movem.l   d1-d3/a0-a1,-(a7)
          lea       speicher(a6),a1     ; Save-Adresse
          move.l    filen(a6),d2        ; Filelnge
          movea.l   chid2(a6),a0        ; CH-ID
          moveq     #-1,d3              ; timeout
          moveq     #$49,d0   ; FS_SAVE
          trap      #3
          movem.l   (a7)+,d1-d3/a0-a1
          tst.l     d0
          rts

; Kanal chid2(a6) schlieen
close2
          movem.l   d0/a0,-(a7)
          movea.l   chid2(a6),a0
          moveq     #2,d0
          trap      #2        ; IO_CLOSE
          tst.l     d0
            bne.s   clos2rts
          clr.l     chid2(a6)
clos2rts  movem.l   (a7)+,d0/a0
          tst.l     d0
          rts
; ---------------------------------------
;   ****  JEDEC-File -> Binr-Brenndaten                    08.09.90
jedtobin
          lea       speicher(a6),a1
          move.w    #$0200,d0           ; Suchbereich
          moveq     #'*',d1             ; '*' suchen
          bsr.s     fbytes
            bne.s   jedrts
          moveq     #$10,d0
          move.w    #'FQ',d1            ; 'QF2194' oder 'QF2706' identifizieren
          bsr.s     fbytes
            bne.s   jedrts
          bsr       gettypbr            ; '4912' oder '6072' -> d5.l
          moveq     #1,d0
          move.l    d5,d1
          bsr.s     fbytes
            bne.s   jedrts
          moveq     #1,d0
          swap      d1
          bsr.s     fbytes
            beq.s   jedcopy
jedrts    rts
; jedecfile kopieren
jedcopy   bsr       gettyple            ; Anzahl input lines 32, 40 -> d5.b
          ext.w     d5
          move.w    d5,d6
          lsl.w     #3,d5               ; 256 oder 320 bits pro Pin
          move.w    d5,d0
          lsl.w     #3,d0               ; 2048 oder 2560 bits fr 8 Pins
          lea       galfile(a6),a3
          adda.w    d0,a3               ; Zeiger auf XOR-bits
          lea       galpuff(a6),a5      ; erst in Puffer einlesen
          movea.l   a5,a2               ; dito
          moveq     #7,d7               ; 8 Pins 19..12
          move.w    #$0100,d0
          moveq     #'L',d1
          bsr.s     fbytes
          bra.s     jed1
/loop     bsr.s     findL
jed1        bne.s   jedrts
          addq.l    #4,a1               ; adressen 0000..1792 weg
          move.w    d5,d0               ; 256 oder 320 bits pro Pin
          bsr.s     copybin             ; (a1)+ -> (a5)+
          dbf       d7,loop
          bra.s     copyxor
; Copy-Hilfsroutinen
findL
          moveq     #4,d0
          moveq     #'L',d1
fbytes
          bra.s     fb3
/loop     cmp.b     (a1)+,d1
            beq.s   fb1
fb3       dbf       d0,loop
fb2       moveq     #9,d0               ; 'kein gltiger JEDEC_File'
          bset      #16,d0              ; trt
          tst.w     d0
          rts
fb1       lsr.w     #8,d1
            beq.s   fb4
          cmp.b     (a1)+,d1
            bne.s   fb2
fb4       moveq     #0,d0
          rts

copybin   bra.s     copybdbf
/loop     move.b    (a1)+,d1
          cmpi.b    #$30,d1
            blt.s   loop
          cmpi.b    #'*',d1
            beq.s   copybrts
          andi.b    #1,d1               ; $00 oder $01
          move.b    d1,(a5)+
          move.b    d1,(a2)+            ; fr csumme in galpuff
copybdbf  dbf       d0,loop
copybrts  rts

copyxor   bsr.s     findL
            bne.s   copybrts
          tst.b     aflg(a6)
            bne     gal_atyp
; fr normale GAL16V8 + GAL20V8 (nicht A-Typen)
          addq.l    #4,a1               ; adresse 2048 weg
          moveq     #4,d0
          lea       $0060(a3),a5
          bsr.s     copybin             ; 4 bit XOR 19..16
          moveq     #4,d0
          lea       $006E(a3),a5        ; 4 bit XOR 15..12
          bsr.s     copybin
          bsr.s     findL
            bne.s   copybrts
          addq.l    #4,a1               ; adresse 2056 weg
          moveq     #64,d0
          lea       (a3),a5
          bsr.s     copybin             ; 64 bit UES
          bsr.s     findL
            bne.s   copybrts
          addq.l    #4,a1               ; adresse 2120 weg
          moveq     #8,d0
          lea       $0065(a3),a5
          bsr.s     copybin             ; 8 bit AC1 19..12
          bsr     findL
            bne.s   copybrts
          addq.l    #4,a1               ; adresse 2128 weg
          moveq     #32,d0
          lea       $0040(a3),a5
          bsr.s     copybin             ; 32 bit PT0..PT31
          moveq     #32,d0
          lea       $0072(a3),a5
          bsr.s     copybin             ; 32 bit PT32..PT63
          bsr       findL
            bne.s   jedrts1
          addq.l    #4,a1               ; adresse 2192 weg
          moveq     #1,d0
          lea       $006D(a3),a5
          bsr     copybin             ; 1 bit SYN
          moveq     #1,d0
          lea       $0064(a3),a5
          bsr     copybin             ; 1 bit ACO
atypret
          moveq     #'C',d1
          moveq     #16,d0
          bsr       fbytes
            beq.s   clabok
claberr   clr.l     psum(a6)
          bra.s     copyrows
clabok    lea       psum(a6),a5
          moveq     #4,d1               ; 4 bytes, a1 Zeiger auf hexascii
          bsr       hextolint           ; C0000 -> psum(a6) als longinteger
            bne.s   claberr
; fuse-matrix spiegeln JEDEC -> GAL  (File einlesen)
; d6.w Anzahl input lines  32 oder 40
copyrows  lea       galpuff(a6),a1      ; Quelle
          lea       galfile(a6),a5      ; Ziel
          moveq     #0,d2               ; Reihe 0
copyrow
          moveq     #63,d0              ; Anzahl PT-1
/loop     move.b    (a1),(a5)+
          adda.w    d6,a1
          dbf       d0,loop

          addq.l    #1,d2
          cmp.w     d6,d2               ; ..bis Reihe 31 oder 39
            bge.s   copyrend
          lea       galpuff(a6),a1
          adda.l    d2,a1               ; nchste Input Line
          bra.s     copyrow
copyrend
          bsr.s     csumme
          cmp.l     psum(a6),d3
            beq.s   psumok
          moveq     #21,d0              ; 'JEDEC-C-Prfsumme fehlerhaft'
          bset      #16,d0
          tst.l     d0
          bra.s     jedrts1
psumok    moveq     #0,d0
jedrts1   rts

; C-Prfsumme bilden -> d3.l, summe(a6)
; d6.w Anzahl Input lines
csumme
          move.w    d6,d5               ; Anzahl reihen
          lsl.w     #3,d5               ; x8 Anzahl bytes der Prfsumme
          lea       galpuff(a6),a1
          moveq     #0,d3               ; Prfsumme = 0
          moveq     #8,d2               ; Anzahl bits in d1
          bsr.s     sumbits
          moveq     #$12,d5             ; 18x8 bytes XOR .. PT63
          bsr.s     sumbits
          moveq     #1,d5
          moveq     #2,d2               ; 1x2 bytes SYN, AC0
          bsr.s     sumbits
          move.l    d3,summe(a6)
          rts
sumbits
          bra.s     matxdbf
sumloop
          moveq     #0,d0
          moveq     #0,d1
/loop     btst      #0,(a1)+            ; '0' oder '1', $00 oder $01
            beq.s   matrix0
          bset      d0,d1
matrix0   addq.w    #1,d0
          cmp.w     d2,d0               ; 8 oder 2
            blt.s   loop
          add.w     d1,d3
matxdbf   dbf       d5,sumloop
          rts
; --------------------------------------
; fr GAL16V8A + GAL20V8A (A-Typen)
gal_atyp
          addq.l    #4,a1               ; adresse 2048 weg
          moveq     #4,d0
          lea       $0040(a3),a5
          bsr       copybin             ; 4 bit XOR 19..16
          moveq     #4,d0
          lea       $008E(a3),a5        ; 4 bit XOR 15..12
          bsr     copybin
          bsr     findL
            bne   copybrts
          addq.l    #4,a1               ; adresse 2056 weg
          moveq     #64,d0
          lea       (a3),a5
          bsr     copybin             ; 64 bit UES
          bsr     findL
            bne   copybrts
          addq.l    #4,a1               ; adresse 2120 weg
          moveq     #4,d0
          lea       $0045(a3),a5
          bsr     copybin             ; 4 bit AC1 19..16
          moveq     #4,d0
          lea       $0089(a3),a5
          bsr     copybin             ; 4 bit AC1 15..12
          bsr     findL
            bne   copybrts
          addq.l    #4,a1               ; adresse 2128 weg
          moveq     #64,d0
          lea       $0049(a3),a5
          bsr     copybin             ; 64 bit PT0..PT63
          bsr       findL
            bne   jedrts1
          addq.l    #4,a1               ; adresse 2192 weg
          moveq     #1,d0
          lea       $008D(a3),a5
          bsr     copybin             ; 1 bit SYN
          moveq     #1,d0
          lea       $0044(a3),a5
          bsr     copybin             ; 1 bit ACO
          bra       atypret

; ----------------------------------------------
; fuse-matrix spiegeln GAL -> JEDEC  (auslesen)
; d6.w Anzahl input lines  32 oder 40
copylins  lea       galpuff(a6),a1      ; Ziel
          lea       galfile(a6),a5      ; Quelle
          moveq     #0,d2               ; Reihe 0
copylin
          moveq     #63,d0              ; Anzahl PT-1
/loop     move.b    (a5)+,(a1)
          adda.w    d6,a1
          dbf       d0,loop

          addq.l    #1,d2
          cmp.w     d6,d2               ; ..bis Reihe 31 oder 39
            bge.s   copylend
          lea       galpuff(a6),a1
          adda.l    d2,a1               ; nchste Input Line
          bra.s     copylin
copylend
          moveq     #0,d0
jedrts2   rts

header
          dc.w      25
          dc.b      $02,$20,$0A,'EPROMMER II JEDEC-File',0  ; $02=STX=^B
text16v8
          dc.w      86
          dc.b      'Typ: GAL16V8  ',$0A
          dc.b      'UES:                  ',$0A
          dc.b      'SIG:$         ',$0A
          dc.b      'ANZ:$         ',$0A
          dc.b      '* ',$0A,'QF2194*QP20*F0'
adr16v8   dc.b      '0000','0256','0512','0768'
          dc.b      '1024','1280','1536','1792'
          dc.b      '2048','2056','2120','2128','2192'
text20v8
          dc.w      86
          dc.b      'Typ: GAL20V8  ',$0A
          dc.b      'UES:                  ',$0A
          dc.b      'SIG:$         ',$0A
          dc.b      'ANZ:$         ',$0A
          dc.b      '* ',$0A,'QF2706*QP24*F0'
adr20v8   dc.b      '0000','0320','0640','0960'
          dc.b      '1280','1600','1920','2240'
          dc.b      '2560','2568','2632','2640','2704'
atyppos   equ       41                  ; ab 'EPROMMER..' bis 'GALxxV8'
uespos    equ       24+21+4             ; ab 'EPROMMER..' bis 'UES: '
sigpos    equ       uespos+23
anzpos    equ       sigpos+15

cpyhead
          move.w    (a1)+,d0
cpyhd0    bra.s     cpydbf1
/loop     move.b    (a1)+,(a5)+         ; JEDEC-Header eintragen
cpydbf1   dbf       d0,loop
          rts

; d6.w Anzahl input lines 32 oder 40
galtojed
          lea       speicher(a6),a5     ; Ziel
          lea       header(pc),a1
          bsr.s     cpyhead
          bsr     cpycrlf
          bsr     cpycrlf
          lea       text16v8(pc),a1
          lea       adr16v8(pc),a3
          cmpi.b    #5,typflg(a6)
            beq.s   c16v8
          lea       text20v8(pc),a1
          lea       adr20v8(pc),a3
c16v8     bsr.s     cpyhead
          tst.b     aflg(a6)
            beq.s   noagal
          move.b    #'A',speicher+atyppos(a6)     ; A-Typ eintragen
noagal
          lea       speicher+sigpos(a6),a1        ; Kennung in Header als ASCII
          move.l    galkennh(a6),longint(a6)
          bsr       lintoas8
          lea       speicher+anzpos(a6),a1        ; Anzahl in Header als ASCII
          move.l    galkennh+4(a6),longint(a6)
          bsr       lintoas8

          lea       galpuff(a6),a1
          bsr.s     cpyadr              ; '* ','L0000', eintragen
          moveq     #7,d4               ; 8 Blcke
cpymap
          moveq     #7,d5               ; 8 Reihen pro Block
cpyblock
          move.w    d6,d0               ; 32 oder 40
          bra.s     cpydbf2
/loop     moveq     #$30,d1
          add.b     (a1)+,d1
          move.b    d1,(a5)+
          add.l     d1,d3
cpydbf2   dbf       d0,loop
          bsr.s     cpycrlf
          dbf       d5,cpyblock
          subq.l    #2,a5               ; crlf weg
          bsr.s     cpyadr              ; L0256..L2048
          dbf       d4,cpymap
          bra.s     cpyxor

cpyadr    move.b    #'*',(a5)+
          move.b    #' ',(a5)+
          move.b    #$0A,(a5)+
          move.b    #'L',(a5)+
          moveq     #3,d0
/loop     move.b    (a3)+,(a5)+
          dbf       d0,loop
cpycrlf   move.b    #' ',(a5)+
          move.b    #$0A,(a5)+
          rts
cpyxor
          tst.b     aflg(a6)
            bne     cpyxora
; normale GAL-Typen (nicht A)
          move.l    a0,d3               ; a0 retten
          movea.l   a1,a0
          movea.l   a1,a2
          suba.l    #galpuff-galfile,a2
          lea       $40+$20(a2),a1
          moveq     #4,d0
          bsr       cpyd0               ; 4 bit XOR 19..16
          lea       $40+$2E(a2),a1
          moveq     #4,d0
          bsr       cpyd0               ; 4 bit XOR 15..12
          bsr.s     cpyadr              ; L2056
          movea.l   a2,a1
          moveq     #$40,d0
          bsr.s     cpyd0               ; 64 bit UES
          bsr.s     cpyadr              ; L2120
          lea       $40+$25(a2),a1
          moveq     #8,d0
          bsr.s     cpyd0               ; 8 bit AC1 19..12
          bsr.s     cpyadr              ; L2128
          lea       $40(a2),a1
          moveq     #$20,d0
          bsr.s     cpyd0               ; 32 bit PT0..PT31
          lea       $40+$32(a2),a1
          moveq     #$20,d0
          bsr.s     cpyd0               ; 32 bit PT32..PT63
          bsr.s     cpyadr              ; L2192
          lea       $40+$2D(a2),a1
          moveq     #1,d0
          bsr.s     cpyd0               ; 1 bit SYN
          lea       $40+$24(a2),a1
          moveq     #1,d0
          bsr.s     cpyd0               ; 1 bit ACO
cpyxaret
          move.b    #'*',(a5)+
          bsr.s     cpycrlf
          move.b    #'C',(a5)+

          movem.l   d3/a0-a5,-(a7)
          bsr       csumme
          move.l    d3,longint(a6)      ; d3.l Prfsumme
          movem.l   (a7)+,d3/a0-a5

          movea.l   a5,a1
          bsr       lintoas4            ; Prfsumme C0000*
          addq.l    #4,a5
          move.b    #'*',(a5)+
          bsr       cpycrlf
          move.b    #$03,(a5)+          ; =ETX=^C
          lea       adr16v8(pc),a1
          moveq     #4,d0
          bsr       cpyhd0              ; '0000'
          bsr       cpycrlf
          move.l    a5,d1
          lea       speicher(a6),a5
          sub.l     a5,d1
          move.l    d1,filen(a6)        ; File-Lnge merken
          movea.l   d3,a0               ; a0 gerettet
          bra.s     cpysign

cpyd0     bra.s     cpyd0dbf
/loop     moveq     #$30,d1
          add.b     (a1)+,d1
          move.b    d1,(a5)+
          move.b    d1,(a0)+
cpyd0dbf  dbf       d0,loop
          rts

; GAL16V8A + GAL20V8A (A-Typen)
cpyxora
          move.l    a0,d3               ; a0 retten
          movea.l   a1,a0
          movea.l   a1,a2
          suba.l    #galpuff-galfile,a2
          lea       $0040(a2),a1
          moveq     #4,d0
          bsr       cpyd0               ; 4 bit XOR 19..16
          lea       $008E(a2),a1
          moveq     #4,d0
          bsr       cpyd0               ; 4 bit XOR 15..12
          bsr     cpyadr              ; L2056
          movea.l   a2,a1
          moveq     #$40,d0
          bsr.s     cpyd0               ; 64 bit UES
          bsr     cpyadr              ; L2120
          lea       $0045(a2),a1
          moveq     #4,d0
          bsr.s     cpyd0               ; 4 bit AC1 19..16
          lea       $0089(a2),a1
          moveq     #4,d0
          bsr.s     cpyd0               ; 4 bit AC1 15..12
          bsr     cpyadr              ; L2128
          lea       $0049(a2),a1
          moveq     #$40,d0
          bsr.s     cpyd0               ; 64 bit PT0..PT63
          bsr     cpyadr              ; L2192
          lea       $008D(a2),a1
          moveq     #1,d0
          bsr.s     cpyd0               ; 1 bit SYN
          lea       $0044(a2),a1
          moveq     #1,d0
          bsr.s     cpyd0               ; 1 bit ACO
          bra       cpyxaret

; UES in JEDEC_Fileheader als ascii oder hex
cpysign
          moveq     #0,d1
          lea       speicher+uespos(a6),a5
          moveq     #31,d0
          moveq     #0,d1
          moveq     #0,d2
/loop     tst.b     (a2)+
            beq.s   cpynull1
          bset      d0,d1               ; d1.l byte 7..4
cpynull1  dbf       d0,loop
          moveq     #31,d0
/loop     tst.b     (a2)+
            beq.s   cpynull2
          bset      d0,d2               ; d2.l byte 3..0
cpynull2  dbf       d0,loop
          move.l    d1,d3
          bsr.s     cpytest             ; d1.l ascii kopieren
            bne.s   cpyhx               ; Fehler -> hex
          move.l    d2,d3
          bsr.s     cpytest             ; d2.l ascii kopieren
            bne.s   cpyhx               ; Fehler -> hex
cpyend    movea.l   (a6),a2
          moveq     #0,d0
          rts
cpytest
          moveq     #3,d0
/loop     rol.l     #8,d3
          tst.b     d3                  ; nur Nullen
            beq.s   cpyd3dbf
          cmpi.b    #-1,d3              ; alles leer
            beq.s   cpyd3dbf
          cmpi.b    #' ',d3             ; nur druckbare Zeichen von ' '
            blt.s   cpyerr
          cmpi.b    #$7F,d3             ; .. bis ''
            bgt.s   cpyerr
          move.b    d3,(a5)+
cpyd3dbf  dbf       d0,loop
          moveq     #0,d0
          rts
cpyerr    moveq     #-1,d0
          rts
; UES als hex kopieren
cpyhx
          lea       speicher+uespos(a6),a1
          move.l    d1,longint(a6)
          bsr       lintoas8
          addq.l    #8,a1
          move.l    d2,longint(a6)
          bsr       lintoas8
          bra.s     cpyend
; ---------------------------------------
;   ****  EPROMMER0 - Routinen  ****                        31.08.90 Jo
inioutp
          moveq     #-1,d3              ; D0..D7 Ausgang
          bra.s     iniall

; INI-Routine
ini       moveq     #0,d3               ; D0..D7 Eingang
iniall    movea.l   io_adr(a6),a5
          moveq     #0,d0               ; DDR-Access DDR-reg
          moveq     #-1,d1              ; DDR-Register Ausgang
          move.l    #$34343434,d2       ; DDR-Access P-reg; CA2, CB2 outputs
; A0..A15 Ausgang, D0..D7 Eingang, Bit 0..7 Ausgang
          move.l    d2,4(a5)            ; alle P-Register anwhlen
          move.l    d0,(a5)             ; alle P-Register auf Null
          move.l    d0,4(a5)            ; alle DDR-Register anwhlen
          move.l    d1,(a5)             ; alle 4 P-Register Ausgang
          move.b    d3,2(a5)            ; D0..D7 Eingang oder Ausgang
          move.l    d2,4(a5)            ; alle P-Register anwhlen
          rts
; ----------------------------------------------------------------------------
; Steuerbyte        bit-Nr    =0                  =1
;                   7         Pin  1 0/Ucc        Pin 1  Upp          Upp/A15
;                   6   frei      Ucc/Upp off         Ucc/Upp on          LED gelb
;                   5         Ucc=5V              Ucc=6V              LED rot
;                   4         Pin 27 /PGM         Pin 27 /PGM         2764, 27128
;                   3         Pin  1 0V           Pin  1 Ucc
;                   2         Pin 22 Ucc          Pin 22 0V           OE
;                   1         Pin 22 0/Ucc        Pin 22 Upp
;                   0         Pin 20 CE=0         Pin 20 CE=Ucc       /CE
;  CB2_0            $3FC6     Eprom 12.5V         Gal 16.5V
;  CB2_1            $3FC7     Ucc/Upp aus         Ucc/Upp ein
; -----------------------------------------------------------------------------
stbytes
;                      ,standby  ,read
;                   wait     ,program  ,wait     ,verify
;  2764   Nr 1
          dc.b      0,0,%01011101,%01011100
          dc.b      %11111000,%11101000,%11111000,%11111100
; 27128   Nr 2
          dc.b      0,0,%01011101,%01011100
          dc.b      %11111000,%11101000,%11111000,%11111100
; 27256   Nr 3
          dc.b      0,0,%01001101,%01001100
          dc.b      %11101001,%11101000,%11101001,%11101101
; 27512   Nr 4
          dc.b      0,0,%01000101,%01000100
          dc.b      %01100011,%01100010,%01100011,%01100100

; GAL16V8 Nr 5         ,edit     ,Anzahl input lines
          dc.b      0,0,%11001101,32
          dc.l      '4912'              ; 2194 Anzahl fuses
; GAL20V8 Nr 6
          dc.b      0,0,%11001101,40
          dc.l      '6072'              ; 2706

zeitk     dc.l      $0000001A           ; Abgleich auf 100 us mit Oszi
          dc.w      -1

; Steuerbytes brennen -> d5.l
gettypbr
          moveq     #4,d0
          bra.s     gettp

; Steuerbytes lesen -> d5.w
gettyple
          moveq     #0,d0
gettp
          moveq     #0,d5
          move.b    typflg(a6),d5
          subq.w    #1,d5
            blt.s   gettyper
          cmpi.b    #maxtyp-1,d5
            bgt.s   gettyper
          lsl.w     #3,d5               ; 8 bytes pro typ
          add.w     d0,d5               ; 0 oder 4
          move.l    stbytes(PC,d5.w),d5
          movea.l   io_adr(a6),a5
          lea       3(a5),a3
          move.b    #$34,6(a5)          ; Upp=12.5 V
          cmpi.b    #5,typflg(a6)
            blt.s   gettypep
          move.b    #$3C,6(a5)          ; Upp=16.5 V
gettypep  moveq     #0,d0
          rts
gettyper  moveq     #-$0F,d0  ; ERR_BP
          rts

; EPROM auslesen / Leertest / Prflesen / Brennen
; GAL auslesen / Leertest / Lschen / Brennen / Sicherung
;         d3.l      loop-Zhler
;         d4.w      SR
;         d5.w      Steuerbytes
;         d6.l      Endadresse im Eprom
;         d7.l      Startadresse im Eprom
;         a1        Zeiger auf aktuelles byte im Speicher
;         a3        Zeiger auf Steuerbyte 3(a5)
;         a5        Zeiger auf io-basis
;         a6        Zeiger auf Datenbereich ( nie verndern ! )
eprlesen
          bsr.s     gettyple            ; Steuerbytes -> d5.w
            bne.s   lesenrts
          bsr.s     eprein
          move.b    d5,(a3)             ; Steuerbyte auf lesen
/loop     move.w    d7,(a5)             ; Eprom-Adresse setzen
          cmp.l     d6,d7               ; fertig ?
            bgt.s   lesenok
          addq.l    #1,d7
          move.b    2(a5),(a1)+         ; byte lesen
          bra.s     loop

; Leertest alle bytes = $FF ?
eprleer
          bsr.s     gettyple            ; Steuerbytes -> d5.w
            bne.s   lesenrts
          bsr.s     eprein
          move.b    d5,(a3)             ; Steuerbyte auf lesen
/loop     move.w    d7,(a5)             ; Eprom-Adresse setzen
          cmp.l     d6,d7               ; fertig ?
            bgt.s   lesenok
          addq.l    #1,d7
          move.b    2(a5),d1            ; byte lesen
          cmpi.b    #-1,d1              ; = $FF ?
            beq.s   loop
          moveq     #-$10,d0  ; ERR_FE
          subq.l    #1,d7               ; Zeigt auf byte <> $FF im Eprom
          suba.l    a1,a1               ; a1=0
          bra.s     lesenerr            ; d1.b fehlerhaftes byte im Eprom

; Prflesen
eprpruef
          bsr       gettyple            ; Steuerbytes -> d5.w
            bne.s   lesenrts
          bsr.s     eprein
          move.b    d5,(a3)             ; Steuerbyte auf lesen
/loop     move.w    d7,(a5)             ; Eprom-Adresse setzen
          cmp.l     d6,d7               ; fertig ?
            bgt.s   lesenok
          addq.l    #1,d7
          move.b    2(a5),d1            ; byte lesen
          cmp.b     (a1)+,d1            ; = speicherbyte ?
            beq.s   loop
          moveq     #-$10,d0  ; ERR_FE
          subq.l    #1,d7               ; Zeigt auf byte im Eprom
          subq.l    #1,a1               ; Zeigt auf byte im Speicher
          bra.s     lesenerr            ; d1.b fehlerhaftes byte im Eprom
lesenok   moveq     #0,d0    ; ERR_ok
lesenerr  ror.w     #8,d5               ; swap byte
          move.b    d5,(a3)            ; Steuerbyte auf standby
lesenrts  tst.l     d0
          rts

; EPROM einschalten auf standby
eprein
          moveq     #0,d0
          move.w    d0,(a5)             ; A15..A0 = L
          move.w    d5,d0
          lsr.w     #8,d0
          move.b    d0,(a3)             ; EPROM standby, GAL Edit modus setzen
          move.b    #$3C,7(a5)          ; Ucc/Upp ein
          moveq     #0,d0
          bset      #22,d0
          bsr       setsel              ; Ucc ein anzeigen
          move.l    zeitk(pc),d0
          mulu      #500,d0             ; 50 ms warten
/loop     subq.l    #1,d0
            bgt.s   loop
          rts

; EPROM brennen
brennen
          bsr       gettyple
            bne.s   lesenrts
          bsr.s     eprein
          bsr       gettypbr
            bne.s   lesenrts
          move      SR,d4               ; SR retten in d4.w
          trap      #0                  ; SUPERVISOR
          ori       #$0700,SR           ; Interrupts aus
nextbyte
          moveq     #0,d3               ; brennloop-Zhler
          move.w    d7,(a5)             ; Adresse im Eprom setzen
          cmp.l     d6,d7               ; fertig ?
            bgt     brennok
          move.b    (a1)+,d1            ; SOLL-byte aus Speicher +1
          addq.l    #1,d7               ; Adresse im Eprom +1
          tst.b     d7
            bne.s   noadr
          bsr       zbrennadr           ; aktuelle Brennadresse anzeigen
noadr     cmpi.b    #-1,d1
            beq.s   nextbyte
verify
          move.b    #-1,2(a5)           ; byte im P-register lschen
          move.b    #$30,6(a5)          ; Data Direction Register D0..D7
          move.b    #0,2(a5)            ; D0..D7 Eingang
          move.b    #$34,6(a5)          ; P-Register anwhlen, Upp=12.5V
          move.b    d5,(a3)             ; Steuerbyte verify
          cmpi.w    #20,d3
            bgt.s   brennerr
          move.l    zeitk(pc),d0
/loop     subq.l    #1,d0               ; 100 us warten
            bgt.s   loop
          move.b    2(a5),d2            ; Eprom-IST-byte lesen
          cmp.b     d1,d2               ; SOLL-byte = IST-byte
            bne.s   brennen0
;     nop
          tst.w     d3                  ; IST-byte war schon richtig
            beq.s   nextbyte
;     nop
          bset      #31,d3              ; Flag brennen2
            bne.s   nextbyte            ; ..war schon gesetzt, nextbyte
          bra.s     brenn1
brennen0  move.b    d2,d0               ; Eprom-byte kopieren
          and.b     d1,d0               ; programmierbar ?
          cmp.b     d1,d0
            bne.s   brennerr            ; geht nicht, abbrechen
          btst      #31,d3              ; 2.Durchlauf ?
            bne.s   brennerr            ; ..ja, Fehler
brenn1    ror.l     #8,d5
          move.b    d5,(a3)             ; Steuerbyte wait
          move.b    #$30,6(a5)          ; DDR
          move.b    #-1,2(a5)           ; D0..D7 Ausgang
          move.b    #$34,6(a5)          ; P-Register, Upp=12.5V
          move.b    d1,2(a5)            ; SOLL-byte anlegen
          move.l    zeitk(pc),d0
          mulu      #10,d0              ; 10 * 0.1 ms = 1 ms
          btst      #31,d3
            beq.s   brennen1            ; 1.Durchlauf
          mulu      d3,d0               ; nochmal dasselbe drauf
brennen1  ror.l     #8,d5
; ------- Brennschleife
          move.b    d5,(a3)             ; Steuerbyte program
/loop     subq.l    #1,d0
            bgt.s   loop                ; Brennzeit
          ror.l     #8,d5
          move.b    d5,(a3)             ; Steuerbyte wait
; -------
          ror.l     #8,d5               ; Steuerbyte verify
          addq.w    #1,d3
          bra       verify
brennok   move      d4,SR               ; USER-Modus, Interrupts ein
          moveq     #0,d4     ; ERR_OK
brennex   bsr       gettyple
          rol.w     #8,d5               ; Steuerbyte standby
          move.b    d5,(a3)
          bsr       zstart              ; ursprngliche Adresse wieder anzeigen
          move.l    d4,d0
          rts
brennerr  move      d4,SR               ; USER-Modus, Interrupts ein
          moveq     #-$10,d4  ; ERR_FE
          subq.l    #1,a1               ; Zeigt auf SOLL-byte im Speicher
          subq.l    #1,d7               ; Zeigt auf Fehlerbyte im Eprom
          move.b    d2,d1               ; d1.b fehlerhaftes byte im Eprom
          bra.s     brennex
; -----------------------------------------------------------------------
; Reihe d7.w lesen -> (a1)+
galreihe
          move.w    d7,(a5)             ; Reihenadresse anlegen
          move.w    d7,(a5)             ; 10 us warten
          bclr      #0,(a3)             ; /STR auf L
          bclr      #0,(a3)             ; ..fr 10 us
          bset      #0,(a3)             ; /STR auf H, Reihe d7.b in Schiebereg
          bset      #0,(a3)             ; ..10 us warten
          move.w    d2,d0               ; 64 oder 82 bit
          subq.w    #1,d0
          bra.s     galdbf              ; Bit 0 sofort lesen
/loop
          bclr      #2,(a3)             ; SCLK auf H
          bclr      #2,(a3)             ; ..10 us
          bset      #2,(a3)             ; SCLK auf L
          bset      #2,(a3)             ; ..10 us
galdbf    moveq     #1,d1               ; D0 ausmaskieren
          and.b     2(a5),d1            ; bit lesen
          move.b    d1,(a1)+            ; ..in galdat(a6) eintragen
          dbf       d0,loop
          rts

; Galkennung Reihe 58 auslesen, Flag setzen
kennlesen
          tst.b     kennflg(a6)
            bne.s   kennrts
          bsr       gettyple
            bne.s   kennerr
          bsr       eprein              ; GAL-EDIT-modus einschalten
kenn58
          lea       galkennb(a6),a1     ; Kennung binr
          moveq     #64,d2              ; 64 bit Kennung
          moveq     #58,d7              ; Reihe 58
          bset      #14,d7              ; A14 = H, Pullup fr SDOUT
          bsr.s     galreihe            ; Reihe 58 lesen -> (a1)+
;         Umwandlung Kennung bin -> hex
          lea       galkennb(a6),a1     ; Kennung binr
          lea       galkennh(a6),a3     ; Kennung hex
          lsr.w     #3,d2               ; d2.w bytes / 8 bit
          subq.w    #1,d2
bytloop
          moveq     #0,d1               ; hex-byte = 0
          moveq     #7,d0               ; 8 bit
/loop
          tst.b     0(a1,d0.w)
            beq.s   bindbf
          bset      #8,d1
bindbf    lsr.w     #1,d1
          dbf       d0,loop
          move.b    d1,(a3)+            ; hex-byte in a3-Puffer
          addq.l    #8,a1               ; 8 bit weiter
          dbf       d2,bytloop
;         Kennung testen
          move.l    galkennh(a6),d1
          lsr.w     #8,d1               ; Hersteller-Kennung weg
          move.b    d1,aflg(a6)         ; Flag A-Typ setzen
            beq.s   kennrts             ; =0: normaler Typ
          andi.w    #$00FB,d1
          cmpi.w    #$0058,d1           ; $58 oder $5C
            bne.s   kennerr
          swap      d1
          cmpi.w    #$0040,d1           ; immer $0040 fr GALxxV8x
            bne.s   kennerr
kennrts   moveq     #0,d0
          rts
kennerr   moveq     #24,d0              ; 'GAL-Typ unbekannt'
          rts

; GALxxV8 Bitmap Auslesen fr JEDEC-File -> galfile(a6)
galausl   lea       galfile(a6),a1
          st        gtojflg(a6)
          bra.s     glesen
; GALxxV8 Bitmap Prflesen -> galdat(a6)
gallesen  lea       galdat(a6),a1
          sf        gtojflg(a6)
glesen
          tst.b     errflg(a6)
            bne.s   galok
          bsr       gettyple
            bne.s   galrts
          moveq     #0,d7               ; Reihe 0, A8 L = Verify
          moveq     #0,d6
          move.b    d5,d6               ; bis Reihe 32 oder 40
          bsr       eprein              ; GAL-EDIT-modus einschalten
          bset      #14,d7              ; A14 = H, Pullup fr SDOUT
          moveq     #64,d2              ; 64 bit lesen
galloop
          bsr       galreihe            ; Reihe d7.w lesen -> (a1)+
          addq.b    #1,d7               ; nchste Reihenadresse
          cmp.b     d6,d7               ; ..bis 32, 40 oder 60
            ble.s   galloop
          cmpi.b    #60,d6              ; fertig ?
            bge.s   galexit
          moveq     #82,d2              ; 82 bits ACW lesen
          moveq     #60,d7              ; Reihe 60
          bset      #14,d7              ; A14 = H, Pullup fr SDOUT
          moveq     #60,d6              ; ..bis Reihe 60
          bra.s     galloop             ; ACW lesen
galexit
          move.b    #-1,(a1)            ; Endflag
          bsr       kenn58              ; Kennung Reihe 58 lesen, aflg setzen
          moveq     #0,d7               ; Reihe 0, A8 L = Verify, A14 L = Pullup
          move.w    d7,(a5)

          tst.b     gtojflg(a6)         ; GAL fr JEDEC-File auslesen ?
            bne.s   docgj               ; ..ja
          movem.l   d1-d7/a0-a5,-(a7)   ; ..nein, Prflesen
          bsr       jedtobin            ; JEDEC nochmal umwandeln (ACW ndern)
          movem.l   (a7)+,d1-d7/a0-a5
          bra.s     galok
docgj
          move.b    d5,d6               ; d6.w 32 oder 40 Reihen
          bsr       copylins        ; GAL-Matrix zurckspiegeln -> galpuff(a6)
          bsr       galtojed        ; galpuff -> JEDECfile ausgelesen
galok
          moveq     #0,d0     ; ERR_OK
galrts    tst.l     d0
          rts

; GALxxV8 Bitmap mit File vergleichen
galcomp
          bsr       gallesen
            bne.s   galrts
          lea       galdat(a6),a1
          lea       galfile(a6),a3
          tst.b     errflg(a6)
            beq.s   galc1
          adda.l    d7,a1
          adda.l    d7,a3
galc1
/loop     move.b    (a1)+,d1
            bmi.s   galok               ; Endflag -1
          cmp.b     (a3)+,d1
            beq.s   loop
          moveq     #-$10,d0  ; ERR_FE
          move.l    a1,d7
          lea       galdat(a6),a1
          sub.l     a1,d7
          subq.l    #1,d7               ; Zeigt auf Fehlerbit im GAL
          movea.l   a3,a1
          subq.l    #1,a1               ; Zeigt auf SOLL-bit im File
          bra.s     galrts              ; d1.b fehlerhaftes bit im GAL

; GALxxV8 testen, ob leer
galtest
          bsr       gallesen
            bne.s   galrts
          lea       galdat(a6),a1
          tst.b     errflg(a6)
            beq.s   galt1
          adda.l    d7,a1
galt1
/loop     move.b    (a1)+,d1
          cmpi.b    #-1,d1
            beq.s   galok               ; Endflag -1
          cmpi.b    #1,d1
            beq.s   loop                ; $01 ok
          moveq     #-$10,d0  ; ERR_FE
          move.l    a1,d7
          lea       galdat(a6),a1
          sub.l     a1,d7
          subq.l    #1,d7               ; Zeigt auf Fehlerbit im GAL
          suba.l    a1,a1               ; a1=0
          bra.s     galrts              ; d1.b fehlerhaftes bit im GAL

; Sicherung durchbrennen
;galsich
;          bsr.s     brenn61             ; Reihe 61 Sicherung setzen
;          moveq     #0,d7               ; Reihe 0, A8 L = Verify
;          move.w    d7,(a5)
;          moveq     #0,d0     ; ERR_OK
;          rts

; Reihe d7.w bis d6.w mit d2.w bit brennen, Daten (a1)+
galbloop
          move.w    d7,(a5)             ; Reihenadresse anlegen, A8 P/V = H
          move.w    d2,d0               ; 64 oder 82 bits
          bra.s     galbdbf
/loop
          move.b    (a1)+,d1            ; bit holen
          lsl.b     #7,d1               ; -> A7 = SDIN
          or.b      d1,d7
          move.w    d7,(a5)             ; SDIN setzen
          move.w    d7,(a5)             ; 10 us warten
          bclr      #2,(a3)             ; SCLK auf H
          bclr      #2,(a3)             ; ..10 us
          bset      #2,(a3)             ; SCLK auf L
          bset      #2,(a3)             ; ..10 us
          bclr      #7,d7
galbdbf   dbf       d0,loop

          move.l    zeitk(pc),d0
          mulu      #100,d0             ; 100 * 0.1 ms = 10 ms
          bclr      #0,(a3)             ; /STR = L
/loop     subq.l    #1,d0               ; ..brennen
            bgt.s   loop
          bset      #0,(a3)             ; /STR = H
          addq.b    #1,d7               ; nchste Reihenadresse
          cmp.b     d6,d7               ; ..bis 32 oder 40, oder...
            ble.s   galbloop
          rts

; GALxxV8 lschen, brennen
galbrenn
          bsr       gettyple
            bne.s   galbrts
          move      SR,d4
          trap      #0                  ; Supervisor
          ori       #$0700,SR           ; Interrupts aus
          bsr       eprein              ; GAL-EDIT-modus einschalten

;          btst      #7,status+$40+14(a6)  ; GAL lschen ? Nr 14 selected ?
;            beq.s   galbrlp             ; ..nein
;          bsr.s     galclr
;          bsr       uccaus
;          move.l    zeitk(pc),d0
;          mulu      #1000,d0            ; 1000 * 0.1 ms = 100 ms
;/loop     subq.l    #1,d0               ; ..warten
;            bgt.s   loop
;          bsr       eprein
galbrlp
          move.l    galkennh+4(a6),d1   ; Anzahl Brennzyklen ausgelesen
          addq.l    #1,d1               ; .. +1 hochzhlen
          bsr.s     intobin             ; d1.l -> binbytes galkennb+$20
          lea       galkennb(a6),a1

          tst.b     dokflg(a6)
            bne.s   brenn00

          bsr.s     brenn57

          moveq     #0,d7               ; Reihe 0, A8 L = Verify
          bset      #8,d7               ; A8 P/V = H
          moveq     #64,d2              ; 64 bits Kennung
          moveq     #58,d6              ; Reihe 58 Kennung
          move.b    d6,d7
          bsr       galbloop
brenn00
          moveq     #0,d7               ; ab Reihe 0
          bset      #8,d7               ; A8 P/V = H
          moveq     #0,d6
          move.b    d5,d6               ; ..bis Reihe 32 oder 40
          moveq     #64,d2              ; 64 bits
          lea       galfile(a6),a1
          bsr       galbloop            ; Reihe 0..d6.w brennen

          moveq     #82,d2              ; 82 bits
          moveq     #60,d6              ; ..bis Reihe 60
          move.b    d6,d7               ; Reihe 60
          bsr       galbloop            ; ACW brennen
galbexit
          move      d4,SR               ; Usermodus
          moveq     #0,d7               ; Reihe 0, A8 L = Verify
          move.w    d7,(a5)
          moveq     #0,d0     ; ERR_OK
galbrts   rts

; Reihe 61 Sicherung durchbrennen
brenn61
          move.w    #$01BD,d7           ; Reihe 61, security cell A7=H, A8=H
          bra.s     brenn100            ; 10 ms

; Reihe 57 Kennung vorbereiten
brenn57
          move.w    #$01B9,d7           ; Reihe 57, A7 = H, A8 = H
brenn100  moveq     #100,d1             ; 10 ms
          bra.s     galclr1

; Reihe 63 Bulk erase
galclr
          move.w    #$01BF,d7           ; Reihe 63, bulk erase, A7 = H, A8 = H
          move.w    #500,d1             ; 50ms
galclr1
          move.w    d7,(a5)
          move.l    zeitk(pc),d0
          mulu      d1,d0               ; d1.w * 0.1 ms = 50 ms oder 10 ms
          bclr      #0,(a3)             ; /STR = L
/loop     subq.l    #1,d0               ; GAL lschen, vorbereiten oder sichern
            bgt.s   loop
          bset      #0,(a3)             ; /STR = H
          moveq     #0,d7               ; Reihe 0, A8=L, A7=L
          move.w    d7,(a5)
          move.l    zeitk(pc),d0
          mulu      d1,d0               ; d1.w * 0.1 ms = 50 ms oder 10 ms
/loop     subq.l    #1,d0               ; ..warten
            bgt.s   loop
          rts                           ; d0.l=0, cond.code Z

; Umwandeln d1.l -> (a1)+ binbytes
intobin
          lea       galkennb+$20(a6),a1
          moveq     #31,d0
/loop
          clr.b     (a1)
          btst      d0,d1
            beq.s   intodbf
          addq.b    #1,(a1)
intodbf   addq.l    #1,a1
          dbf       d0,loop
          rts

; ---------------------------------------
; Hilfsroutinen

; d0.l gesetzte bits 24..0 setzen loose menu item auf available
clrloose  movem.l   d1-d2/a1,-(a7)
          moveq     #$01,d2
          bra.s     setstat

; d0.l gesetzte bits 24..0 setzen loose menu item auf selected
setsel    movem.l   d1-d2/a1,-(a7)
          moveq     #$81,d2
          bra.s     setstat

; d0.l gesetzte bits 24..0 setzen loose menu items auf unavailable
setunavl  movem.l   d1-d2/a1,-(a7)
          moveq     #$11,d2
setstat   movea.l   (a4),a1             ; a4 working definition, a1 status
          moveq     #24,d1
/loop     btst      d1,d0
            beq.s   lclr
          move.b    d2,$40(a1,d1.w)
lclr      dbf       d1,loop
          moveq     #-1,d3              ; selectiv
          jsr       $2C(a2)   ; WM_LDRAW
          movem.l   (a7)+,d1-d2/a1
          rts

; longint(a6) -> ascii (a1) mit 2 bytes
lintoas2
          movem.l   d0-d5/a0-a4,-(a7)
          moveq     #2,d5               ; 2 Stellen
          bra.s     itohl

; longint(a6) -> ascii (a1) mit 8 bytes
lintoas8
          movem.l   d0-d5/a0-a4,-(a7)
          moveq     #8,d5               ; 8 Stellen
          bra.s     itohl

; longint(a6) -> ascii (a1) mit 4 bytes
lintoas4
          movem.l   d0-d5/a0-a4,-(a7)
          moveq     #4,d5               ; 4 Stellen
itohl
          move.l    a6,-(a7)
          move.l    a1,d4
          lea       hexbuff(a6),a0      ; Zeiger auf ascii-buffer
          lea       longint(a6),a1      ; Zeiger auf longinteger
          suba.l    a6,a6
          movea.w   $FE,a2    ; CN_ITOHL
          jsr       (a2)
          movea.l   (a7)+,a6
          lea       hexbuff(a6),a0
          moveq     #8,d0
          sub.w     d5,d0
          adda.l    d0,a0
          movea.l   d4,a1
          bra.s     chex
/loop     move.b    (a0)+,(a1)+
chex      dbf       d5,loop
          movem.l   (a7)+,d0-d5/a0-a4
          rts

; ascii (a1), Lnge d1.w -> longinteger (a5)
hextolint
          movem.l   d1-d3/d7/a0-a6,-(a7)
          movea.l   a1,a0               ; pointer to ascii
          move.l    a0,d7
          ext.l     d1
          add.l     d1,d7               ; ascii end pointer
          move.l    a5,a1
          addq.l    #4,a1               ; pointer to stack
          suba.l    a6,a6
          movea.w   $10E,a2
          jsr       (a2)      ; CN_HTOIL
          movem.l   (a7)+,d1-d3/d7/a0-a6
          tst.l     d0
          rts

; Adressen Start, Ende, Filestart anzeigen
showadr   movem.l   d0-d2/a1,-(a7)
          moveq     #0,d2
          moveq     #13,d1
          bset      d1,d2
          lea       hxstart(a6),a1
          jsr       $4C(a2)   ; WM_STLOB
          moveq     #15,d1
          bset      d1,d2
          lea       hxend(a6),a1
          jsr       $4C(a2)   ; WM_STLOB
          moveq     #16,d1
          bset      d1,d2
          lea       hxfstart(a6),a1
          jsr       $4C(a2)   ; WM_STLOB
          move.l    d2,d0
          bsr       clrloose
          movem.l   (a7)+,d0-d2/a1
          rts

; Startadresse Eprom anzeigen
zstart
          movem.l   d0-d7/a0-a4,-(a7)
          lea       hxstart(a6),a1
          bra.s     zitem13

; Brennadresse Eprom anzeigen
zbrennadr
          movem.l   d0-d7/a0-a4,-(a7)
          lea       readbuff+2(a6),a1
          move.l    d7,longint(a6)
          bsr       lintoas4
          move.w    #4,-(a1)
zitem13
          moveq     #13,d1
          jsr       $4C(a2)   ; WM_STLOB
          moveq     #0,d0
          bset      d1,d0
          bsr       clrloose
          movem.l   (a7)+,d0-d7/a0-a4
          rts

; Sockelbild + Beschriftung
objnr
          dc.w      0,15,16,20,22
dilliste
; 2764
          dc.w      uppobj-dilliste
          dc.w      prgobj-dilliste
          dc.w      ncobj-dilliste
          dc.w      oeobj-dilliste
          dc.w      ceobj-dilliste
; 27128
          dc.w      uppobj-dilliste
          dc.w      prgobj-dilliste
          dc.w      a13obj-dilliste
          dc.w      oeobj-dilliste
          dc.w      ceobj-dilliste
; 27256
          dc.w      uppobj-dilliste
          dc.w      a14obj-dilliste
          dc.w      a13obj-dilliste
          dc.w      oeobj-dilliste
          dc.w      prgobj-dilliste
; 27512
          dc.w      a15obj-dilliste
          dc.w      a14obj-dilliste
          dc.w      a13obj-dilliste
          dc.w      upprobj-dilliste
          dc.w      prgobj-dilliste
chgdil
          movem.l   d1/d3/a1/a3/a5,-(a7)
          moveq     #-1,d3
          bclr      #9,d3
          moveq     #0,d0
          move.b    typflg(a6),d0
          cmpi.b    #5,d0
            blt.s   setdil28
            beq.s   setdil20
; setdil24
          bclr      #12,d3
          bclr      #13,d3
          bra.s     idraw
setdil20
          bclr      #10,d3
          bclr      #11,d3
          bra.s     idraw
setdil28
          subq.w    #1,d0
          mulu      #$000A,d0
          lea       dilliste(pc,d0.w),a5
          moveq     #14,d1              ; window-nr
          swap      d1
          lea       objnr(pc),a3
          moveq     #4,d3
/loop     move.w    (a5)+,d0
          lea       dilliste(pc,d0.w),a1
          move.w    (a3)+,d1
          jsr       $50(a2)   ; WM_STIOB
          dbf       d3,loop
          bclr      #14,d3
          bclr      #15,d3
idraw     jsr       $3C(a2)   ; WM_IDRAW
          movem.l   (a7)+,d1/d3/a1/a3/a5
          rts

; Fehleranzeige 'Adresse Soll Ist'
;         d7.l      Adresse im Eprom 0..FFFF
;         (a1)      zeigt auf Soll, oder = 0
;         d1.b      Ist
meldung
          movem.l   d0-d2/a0-a5,-(a7)
          moveq     #0,d2
          move.b    #-1,d2
          move.l    a1,d0
            beq.s   sollmi
          move.b    (a1),d2
sollmi    lea       readbuff(a6),a5
          lea       err16(pc),a0
          move.w    (a0)+,d0
          move.w    d0,(a5)+
          bra.s     cerrdbf
/loop     move.b    (a0)+,(a5)+
cerrdbf   dbf       d0,loop
          move.l    d7,longint(a6)
          lea       readbuff+2+hpos1(a6),a1
          bsr       lintoas4            ; Adresse: 0000
          move.l    d2,longint(a6)
          lea       readbuff+2+hpos2(a6),a1
          bsr       lintoas2            ; Soll: 00
          ext.w     d1
          ext.l     d1
          move.l    d1,longint(a6)
          lea       readbuff+2+hpos3(a6),a1
          bsr       lintoas2            ; Ist: 00
          movem.l   (a7)+,d0-d2/a0-a5
          addq.l    #1,a1
          addq.l    #1,d7
          st        errflg(a6)
; Meldung anzeigen mit trt
          movem.l   d0-d3/a0-a1,-(a7)
          moveq     #-1,d0
          tst.b     tonflg(a6)
            beq.s   noton
          bsr.s     ton
noton     moveq     #4,d2
          swap      d2
          lea       readbuff(a6),a1
          bra.s     erranz

; Fehleranzeige
errorld   movem.l   d0-d3/a0-a1,-(a7)
          movea.l   wmanv(a6),a2
          moveq     #4,d2
          swap      d2                  ; window nr 4, obj nr 0
          tst.b     tonflg(a6)          ; TON selected ?
            beq.s   nixton
          bsr.s     ton
nixton    tst.l     d0
            bmi.s   qdoserr
          cmpi.w    #$7F,d0
            blt.s   doerror
          moveq     #0,d0
doerror   add.w     d0,d0
          lea       errtab(pc),a1
          move.w    0(a1,d0.w),d0
          lea       errstrg(pc),a1
          lea       0(a1,d0.w),a1
          bra.s     erranz
qdoserr   jsr       $74(a2)   ; WM_ERSTR
erranz    move.l    d2,d1
          jsr       $50(a2)   ; WM_STIOB
          moveq     #-1,d3
          swap      d2
          bclr      d2,d3
          jsr       $3C(a2)   ; WM_IDRAW
          movem.l   (a7)+,d0-d3/a0-a1
          tst.l     d0
          rts

; Ton ausgeben: bit #16 trt, bit #17 klick
ton       movem.l   d0-d1/d5/d7/a3,-(a7)
          lea       trootton(pc),a3
          btst      #16,d0
            bne.s   ton1
          btst      #17,d0
            beq.s   tonend
          lea       klickton(pc),a3
ton1      moveq     #$11,d0
          trap      #1        ; MT_IPCOM
tonend    movem.l   (a7)+,d0-d1/d5/d7/a3
          rts
klickton  dc.w      $0A08,$0000,$AAAA   ; %1010101010101010
          dc.w      $1E1E               ; pitch1, pitch2
          dc.l      $00010001           ; intervall steps, sound duration
          dc.w      $0000               ; step in pitch,wrap,ramdom,fuzzi
          dc.w      $0100               ; no reply
trootton  dc.w      $0A08,$0000,$AAAA   ; %1010101010101010
          dc.w      $1020               ; pitch1, pitch2
          dc.l      $000A000A           ; intervall steps, sound duration
          dc.w      $0000               ; step in pitch,wrap,ramdom,fuzzi
          dc.w      $0100               ; no reply

; --------------------------------------
; Pull down action routine EDITOR  Nr 11
; --------------------------------------
fenster
          tst.b     fileflg(a6)
            bne.s   ediok
          moveq     #3,d0               ; 'keine Datei geladen'
          bset      #17,d0
          bsr       errorld
          bra       edinix
ediok     move.w    #$1A0,d2            ; x-pos
          swap      d2
          move.w    $26(a4),d2          ; ww_yorg
          add.w     #$30,d2             ; ..unter Kopfzeilen
; working definition anlegen
          moveq     #0,d1               ; default size
          bsr       clrwrk
          lea       status1(a6),a1
          lea       windef1(pc),a3
          lea       wrkdef1(a6),a4
          jsr       $04(a2)   ; WM_SETUP
          move.l    d2,d1               ; position
          jsr       $10(a2)   ; WM_PULLD
          lea       eprftext(pc),a5
          tst.b     fileflg(a6)         ; EPROM -1, JEDEC +1
            bmi.s   eprfen
          lea       jedftext(pc),a5
eprfen    lea       readbuff(a6),a1
          bsr       copymld             ; (a5)+,(a1)+
          lea       speicher(a6),a5
          move.l    a5,longint(a6)
          bsr       lintoas8            ; longint(a6) -> ascii (a1)
          lea       readbuff(a6),a1
          addq.w    #8,(a1)
          moveq     #0,d1               ; window-nr 0, obj-nr 0
          jsr       $50(a2)   ; WM_STIOB
          jsr       $1C(a2)   ; WM_WDRAW
          movea.l   $70(a4),a3
          movea.l   (a3),a3
          lea       scontr(a6),a5
          move.l    a5,$46(a3)
          move.w    #4,$5E(a3)
          move.w    #$0002,$62(a3)
          move.l    filen(a6),d0
          lsr.l     #2,d0
          move.w    d0,$92(a3)
          lea       speicher(a6),a5
          moveq     #17,d0
          bsr       outzeile            ; 17 Zeilen senden
            bne.s   cancel1
          jsr       $24(a2)   ; WM_INDEX
; read pointer loop
readpnt
/loop     movea.l   (a4),a1   ; status
          jsr       $30(a2)   ; WM_RPTR
;          tst.l     d0
            bmi     kill
          btst      #$11,$15(a1)        ; cancel
            bne.s   cancel1
          bra.s     loop
cancel1
          moveq     #1,d0
          bsr       clrloose            ; ESC aus
          moveq     #-1,d1
          jsr       $14(a2)   ; WM_UNSET
          moveq     #2,d0
          trap      #2        ; IO_CLOSE
          lea       wrkdef(a6),a4
          movea.l   $08(a4),a0          ; CH-ID
          movea.l   (a4),a1             ; status
          btst      #7,$41(a1)          ; HW-TEST Nr 1
            beq.s   edinix
          bsr       ini                 ; alles auf 0, D0..D7 Eingang
          moveq     #2,d0               ; HW-TEST aus
          bset      #22,d0              ; Ucc aus
          bra.s     tstnix
edinix    moveq     #0,d0
          bset      #11,d0              ; EDITOR aus
tstnix    bsr       clrloose
nix       moveq     #0,d4
          moveq     #0,d0
          rts

; String (a5)+ -> (a1)+ kopieren
copymld
          moveq     #$1F,d0             ; max 32 bytes
          and.w     (a5)+,d0            ; Lnge string
          move.w    d0,(a1)+
          bra.s     mlddbf
/loop     move.b    (a5)+,(a1)+
mlddbf    dbf       d0,loop
          moveq     #0,d0
          rts

; Action-routine START
fenstneu
          lea       speicher(a6),a5
balken    moveq     #17,d0
          bsr.s     outzeile
            bne.s   anferr
          movea.l   $70(a4),a3
          movea.l   (a3),a3
          jsr       $24(a2)   ; WM_INDEX
          moveq     #2,d0
          bsr       clrloose
          bra.s     nix
anferr    moveq     #$11,d4
          rts

; Appl. sub-window  HIT - Routine
applhit
          cmpi.w    #2,d2               ; 1=hit, 2=do, -1.l=ext.hit
            bgt.s   applok
          moveq     #$03,d0
          and.b     $17(a1),d0          ; keyclick / key down
            beq.s   applok
          btst      #0,d0
            bne.s   tsthit
          tst.b     doflg(a6)
            bne.s   tstdo
tsthit    tst.b     d4
            bne.s   tstdo
; Hit auf Fenster: 1 Zeile
          moveq     #1,d0               ; 1 Zeile
          sf        doflg(a6)
          bra.s     hit1
; Do auf Fenster: 12 Zeilen
tstdo     moveq     #17,d0
          st        doflg(a6)
hit1
          bsr.s     outzeile
            bne.s   applerr
          movea.l   $70(a4),a3
          movea.l   (a3),a3
          jsr       $24(a2)   ; WM_INDEX
applok    moveq     #0,d4
          moveq     #0,d0
          rts
applerr   moveq     #$11,d4             ; cancel
          rts

; d0.w Zeilen HEX oder Ascii auf Fenster senden
outzeile
          movem.l   d1-d3/d7/a1,-(a7)
          move.w    d0,d7               ; Anzahl Zeilen
          lea       speicher(a6),a1
          adda.l    filen(a6),a1
          move.l    a1,d6               ; Zeiger auf byte Ende
          moveq     #0,d1
          moveq     #7,d2
          jsr       $60(a2)   ; WM_SWAPP
          moveq     #-1,d3              ; timeout
          cmpi.w    #1,d7
            beq.s   out1z
          moveq     #$20,d0   ; SD_CLEAR
          trap      #3
          bra.s     out17z
out1z     moveq     #0,d1               ; Spalte 0
          moveq     #16,d2              ; Zeile 16
          moveq     #$10,d0   ; SD_POS
          trap      #3
          moveq     #$0A,d1
          moveq     #5,d0     ; IO_SBYTE
          trap      #3
out17z    lea       speicher(a6),a1
          tst.b     fileflg(a6)         ; HEX -1, JEDEC +1
            bmi.s   hexdump
; JEDEC-Anzeige
          cmpi.b    #1,d7
            beq.s   lzeile1             ; hit auf Fenster: 1 Zeile
          subq.l    #1,a5
/loop     cmpi.b    #$0A,-(a5)
            beq.s   lzeile
          cmp.l     a1,a5
            bgt.s   loop
          bra.s     outsdbf
lzeile    addq.l    #1,a5               ; a5 zeigt auf vorige Zeile
lzeile1   movea.l   a5,a1
          bra.s     outsdbf
outstrg
          movea.l   a1,a5               ; a1 Zeiger auf string
          moveq     #$44,d0             ; max. Anzahl bytes pro Zeile = 68
/loop     cmpi.b    #$0A,(a5)+
            beq.s   lfgef
          cmp.l     d6,a5
            bge.s   outzok
          dbf       d0,loop
          moveq     #-4,d0    ; ERR_OR
          bra.s     outzerr
lfgef     move.l    a5,d2
          sub.l     a1,d2               ; d2.w Anzahl bytes
          moveq     #7,d0     ; IO_SSTRG
          trap      #3
          tst.l     d0
            bne.s   outzerr
outsdbf   cmp.l     d6,a1
            bge.s   outzok
          dbf       d7,outstrg

outzok    moveq     #0,d0
outzerr   movea.l   a1,a5               ; a5 updated pointer
          lea       speicher(a6),a1
          move.l    a5,d2
          sub.l     a1,d2
          lsr.l     #2,d2
          move.w    d2,scontr+6(a6)     ; Scrollbar-Lnge
          movem.l   (a7)+,d1-d3/d7/a1
          tst.l     d0
          rts
; HEX-Anzeige
hexdump
          cmpi.b    #1,d7
            beq.s   hexdbf              ; hit auf Fenster: 1 Zeile
          moveq     #$10,d2
          suba.l    d2,a5               ; a5 zeigt auf vorige Zeile
          cmpa.l    a1,a5
            bge.s   hexdbf
          movea.l   a1,a5               ; auf Anfang begrenzen
          bra.s     hexdbf
hexdloop
          lea       speicher(a6),a1
          move.l    a5,d0
          sub.l     a1,d0
          move.l    d0,longint(a6)
          lea       readbuff(a6),a1
          move.b    #'L',(a1)+
          bsr       lintoas4
          moveq     #' ',d2
          addq.l    #4,a1
          move.b    d2,(a1)+
          move.b    d2,(a1)+

          moveq     #3,d3               ; 4 longinteger
/loop     move.l    (a5)+,longint(a6)
          bsr       lintoas8
          addq.l    #8,a1
          move.b    d2,(a1)+
          dbf       d3,loop

          subq.l    #8,a5
          subq.l    #8,a5
          move.b    d2,(a1)+
          move.b    d2,(a1)+

          moveq     #15,d3              ; 16 bytes Ascii
/loop     move.b    (a5)+,d1
          cmp.b     d2,d1
            bcs.s   ascinok
          tst.b     d1
            bpl.s   asciok
ascinok   moveq     #'.',d1
asciok    move.b    d1,(a1)+
          dbf       d3,loop

          move.b    #$0A,(a1)+          ; LF
          moveq     #62,d2              ; 62 bytes schicken
          lea       readbuff(a6),a1
          moveq     #7,d0     ; IO_SSTRG
          trap      #3
          tst.l     d0
            bne.s   hexzerr
hexdbf    cmpa.l    d6,a5
            bge.s   hexzok
          dbf       d7,hexdloop

hexzok    moveq     #0,d0
hexzerr   lea       speicher(a6),a1
          move.l    a5,d2
          sub.l     a1,d2
          lsr.l     #2,d2
          move.w    d2,scontr+6(a6)     ; Scrollbar-Lnge
hexret    movem.l   (a7)+,d1-d3/d7/a1
          tst.l     d0
          rts

; CONTROLL-Routine menu appl. sub-window Scrollbalken
applcontr
          moveq     #-1,d0
          cmp.l     d0,d3               ; scrollbalken ?
            beq.s   gonoevnt            ; ..nein
          cmpi.w    #$7C00,d2           ; join nicht eingebaut
gonoevnt    beq     noevent
cntrlhit  movea.l   $70(a4),a3
          movea.l   (a3),a3
          move.w    d3,d0               ; Lnge des Balkens
          clr.w     d3
          swap      d3                  ; Position von Hit
          mulu      $92(a3),d3          ; * Lnge des Files
          divu      d0,d3               ; / Lnge des Balkens
          ext.l     d3                  ; Divisions-Rest wegwerfen
          lea       scontr(a6),a5
          move.w    d3,6(a5)            ; in sclstatus eintragen
          lsl.l     #2,d3               ; *4 Abstand von speicher in bytes
          clr.b     d3
          lea       speicher(a6),a5
          add.l     d3,a5               ; neue adresse
          bra       balken              ; fertig malen

clrbuff
          lea       readbuff(a6),a1
          move.w    #ladenam-readbuff,d0
          bra.s     clrram
clrwrk
          lea       status1(a6),a1
          move.w    #scontr-status1,d0
clrram
          lsr.w     #2,d0
          bra.s     clrwdbf
/loop     move.l    d1,(a1)+
clrwdbf   dbf       d0,loop
          rts
; ------------------------------------------------------
; Pull down action routine Nr 1 HW-TEST
; ------------------------------------------------------
ainfo
          move.w    #$01A2,d2           ; x-pos war $C8
          swap      d2
          move.w    $26(a4),d2          ; ww_yorg
          add.w     #$34,d2             ; ..unter Kopfzeilen
; working definition anlegen
          moveq     #0,d1               ; default size
          bsr.s     clrwrk              ; clear working area
          bsr.s     clrbuff             ; clear readbuff
          move.w    #$3434,readbuff+$42(a6)
          lea       status1(a6),a1
          lea       windef2(pc),a3
          lea       wrkdef1(a6),a4
          jsr       $04(a2)   ; WM_SETUP
          move.l    d2,d1               ; position
          jsr       $10(a2)   ; WM_PULLD
          jsr       $1C(a2)   ; WM_WDRAW
          move.l    #%101010001000010000,d0       ; Nr 4,9,13,15,17 selected
          bsr       setsel
          bra       readpnt

; action routine Nr 2  A0..A15; Nr 3  D0..D7
adinp
          lea       readbuff(a6),a1
          moveq     #4,d3               ; 4 bytes A0..A15 '0000'
          bra.s     hxadin
dainp
          lea       readbuff+$20(a6),a1
          moveq     #2,d3               ; 2 bytes D0..D7  '00'
hxadin
          lea       $10(a1),a5          ; dc.l integer
          move.w    $10(a3),d1          ; Item Nr 2 oder 3
          move.w    d1,d6
          move.l    a1,d5               ; a1 retten
          moveq     #0,d2
          jsr       $5C(a2)   ; WM_SWLIT
          movea.l   d5,a1               ; pointer to name buffer
          jsr       $68(a2)   ; WM_RNAME
            bmi.s   hxaerr
            bgt.s   hxaok
          move.w    (a1),d0             ; Lnge string
            beq.s   hxaok
          move.w    d3,d1
          move.w    d1,(a1)+            ; d1.w 2 oder 4 bytes
          bsr       hextolint           ; a1 hexascii, d1.w -> a5 longinteger
            beq.s   hxarts
          clr.l     (a5)
hxarts    move.l    (a5),longint(a6)
          cmpi.w    #2,d3
            beq.s   linas2
          bsr       lintoas4
          bra.s     zhxa
linas2    bsr       lintoas2
zhxa      move.w    d6,d1
          subq.l    #2,a1
          jsr       $4C(a2)   ; WM_STLOB
          moveq     #0,d0
          bset      d1,d0
          bsr       clrloose
          bsr.s     outbytes
hxaok
          moveq     #0,d4
          moveq     #0,d0
hxaerr
          rts
outbytes
          bsr       inioutp           ; io_adr->a5; alle P-reg auf Ausgang
          move.w    readbuff+$42(a6),d0           ; 5/6V, 12.5/16.5V
            beq.s   nichtges
          move.w    d0,6(a5)
nichtges  move.w    readbuff+$12(a6),d0           ; A0..A15
          swap      d0
          move.b    readbuff+$33(a6),d1           ; D0..D7
          lsl.w     #8,d1
          move.w    d1,d0
          move.b    readbuff+$40(a6),d0           ; Steuerbyte
          move.l    d0,(a5)                       ; alles rausschicken
          rts

; action routine Pin1 Nr 4..8
pin1_l
pin1_h
pin1_a15
          move.l    #%00000000000000111110000,d0
          bra.s     showpin
pin1_12
pin1_16
          move.l    #%00000000001100111110000,d0
          bra.s     showpin

; action routine Pin22 Nr 9..12, 21
pin22_l
pin22_h
          move.l    #%01000000001111000000000,d0
          bra.s     showpin
pin22_12
pin22_16
          move.l    #%01000000001111011000000,d0
          bra.s     showpin

; action routine Pin20 Nr 13, 14, 22
pin20_l
pin20_h
          move.l    #%10000000110000000000000,d0
          bra.s     showpin

;action routine Pin27 Nr 15, 16, 19
pin27_l
pin27_h
pin27_14
          move.l    #%00010011000000000000000,d0
          bra.s     showpin

; action routine Pin28 Nr 17, 18, 20
pin28_0
pin28_5
pin28_6
          move.l    #%00101100000000000000000,d0
;          bra.s     showpin
;          nop
showpin
          move.w    $10(a3),d1
          bclr      d1,d0
          bsr       clrloose
showpin1
          bsr       setbytes
          bsr       outbytes
p22ok
          moveq     #0,d4
          moveq     #0,d0
          rts
; action routine Nr 0, BLITZ, alle pins nullen
pinneu
p22rts    moveq     #-1,d0
          bsr       clrloose
          move.l    #%00000101010001000010000,d0    ; Nr 4,9,13,15,17 selected
          bsr       setsel
          bra.s     showpin1

; action routine Nr 21
p22_mux
          moveq     #-1,d0              ; alles aus
          bsr       clrloose
          move.l    #%01001001010101000010000,d0    ; Nr 4,9,11,13,15,18,21
          bsr       setsel
          bsr.s     showpin1
p22_muxc
          lea       3(a5),a3            ; Adresse Steuerbyte
          move.l    zeitk(pc),d3
          mulu      #10,d3              ; 10 * 0.1 us = 1 ms
          movea.l   (a4),a1             ; status
          btst      #7,$40+21(a1)
            beq.s   p22rts
          move      SR,d4
          trap      #0
          ori       #$0700,SR
          move.w    #%0000010000000010,d5 ; bytes verify, program
          move.w    #499,d6             ; 500 * 2 * 1 ms = 1 s
rechteck
          move.l    d3,d0
          rol.w     #8,d5
          move.b    d5,(a3)             ; program
/loop     subq.l    #1,d0
            bgt.s   loop
          rol.w     #8,d5
          move.b    d5,(a3)             ; verify
          move.l    d3,d0
/loop     subq.l    #1,d0
            bgt.s   loop
          dbf       d6,rechteck
          move      d4,SR
          bsr       ioprptr
          moveq     #3,d0
          and.b     $17(a1),d0
            beq.s   p22_loop
          move.b    #$01,$40+21(a1)
          moveq     #-1,d3
          jsr       $2C(a2)   ; WM_LDRAW
p22_loop  bra       p22_muxc

; action routine Nr 22, GAL
p20_prg
          moveq     #-1,d0              ; alles aus
          bsr       clrloose
          move.l    #%10011000110011010000000,d0 ; Nr 7,9,10,13,14,18,19,22
          bsr       setsel
          bsr       showpin1
p20_prgc
          lea       3(a5),a3            ; Adresse Steuerbyte
          movea.l   (a4),a1             ; status
          btst      #7,$40+22(a1)
            beq     p22rts
          move      SR,d4
          trap      #0
          ori       #$0700,SR
          lea       galfile(a6),a1
          moveq     #0,d7
          bset      #8,d7
          move.w    #99,d6              ; 100 * 10 ms = 1s
galtloop
          move.w    d7,(a5)             ; Reihenadresse anlegen, A8 P/V = H
          move.w    #63,d0              ; 64  bits
/loop
          move.b    (a1),d1             ; dummy bit holen
          lsl.b     #7,d1               ; -> A7 = SDIN
          or.b      d1,d7
          move.w    d7,(a5)             ; SDIN setzen
          move.w    d7,(a5)             ; 10 us warten
          bclr      #2,(a3)             ; SCLK auf H
          bclr      #2,(a3)             ; ..10 us
          bset      #2,(a3)             ; SCLK auf L
          bset      #2,(a3)             ; ..10 us
          bclr      #7,d7
          dbf       d0,loop

          move.l    zeitk(pc),d0
          mulu      #100,d0             ; 100 * 0.1 ms = 10 ms
          bclr      #0,(a3)             ; /STR = L
/loop     subq.l    #1,d0               ; ..brennen
            bgt.s   loop
          bset      #0,(a3)             ; /STR = H
          dbf       d6,galtloop
;
          move      d4,SR
          bsr.s     ioprptr
          moveq     #3,d0
          and.b     $17(a1),d0
            beq.s   p20_loop
          move.b    #$01,$40+22(a1)
          moveq     #-1,d3
          jsr       $2C(a2)   ; WM_LDRAW
p20_loop  bra       p20_prgc

; Pointer lesen mit trap#3
ioprptr
          movea.l   8(a4),a0            ; CH-ID
          movea.l   (a4),a1             ; status
          move.l    $20(a1),d1          ; x,y pointer coordinates
          moveq     #%00110011,d2       ; d2.b termination vector
          addq.l    #8,a1               ; pointer to pointer record
          moveq     #5,d3               ; timeout 100 ms
          moveq     #$71,d0             ; IOP_RPTR
          trap      #3
          subq.l    #8,a1               ; pointer to status
          move.l    d1,$20(a1)          ; x,y pointer coordinates
          rts

; Steuerbyte d5, Ein/Aus d3, 12/16V d4 setzen
setbytes
          moveq     #0,d5               ; Steuerbyte = 0
          lea       $44(a1),a1          ; Status Item Nr 4
          moveq     #7,d1               ; $80 oder $81, Item selected

setb4     btst      d1,(a1)+            ; 4: Pin1 L
            beq.s   setb5
          bclr      #3,d5
          bclr      #7,d5
          bclr      #7,readbuff+$12(a6) ; A15 auf 0
setb5     btst      d1,(a1)+            ; 5: Pin1 H
            beq.s   setb6
          bset      #3,d5
          bclr      #7,d5
setb6     btst      d1,(a1)+            ; 6: Pin1 12V
            beq.s   setb7
          bset      #3,d5
          bset      #7,d5
          moveq     #$34,d4             ; 12.5 V
setb7     btst      d1,(a1)+            ; 7: Pin1 16V
            beq.s   setb8
          bset      #3,d5
          bset      #7,d5
          moveq     #$3C,d4             ; 16.5 V
setb8     btst      d1,(a1)+            ; 8: Pin1 A15
            beq.s   setb9
          bclr      #3,d5
          bclr      #7,d5
setb9     btst      d1,(a1)+            ; 9: Pin22 L
            beq.s   setb10
          bclr      #1,d5
          bset      #2,d5
setb10    btst      d1,(a1)+            ; 10: Pin22 H
            beq.s   setb11
          bclr      #1,d5
          bclr      #2,d5
setb11    btst      d1,(a1)+            ; 11: Pin22 12V
            beq.s   setb12
          bset      #1,d5
          bclr      #2,d5
          moveq     #$34,d4
setb12    btst      d1,(a1)+            ; 12: Pin22 16V
            beq.s   setb13
          bset      #1,d5
          bclr      #2,d5
          moveq     #$3C,d4
setb13    btst      d1,(a1)+            ; 13: Pin20 L
            beq.s   setb14
          bclr      #0,d5
setb14    btst      d1,(a1)+            ; 14: Pin20 H
            beq.s   setb15
          bset      #0,d5
setb15    btst      d1,(a1)+            ; 15: Pin27 L
            beq.s   setb16
          bclr      #4,d5
          bclr      #6,readbuff+$12(a6) ; A14 auf 0
setb16    btst      d1,(a1)+            ; 16: Pin27 H
            beq.s   setb17
          bset      #4,d5
setb17    btst      d1,(a1)+            ; 17: Pin28 0V
            beq.s   setb18
          moveq     #$34,d3
setb18    btst      d1,(a1)+            ; 18: Pin28 5V
            beq.s   setb19
          moveq     #$3C,d3
          bclr      #5,d5
setb19    btst      d1,(a1)+            ; 19: Pin27 A14
            beq.s   setb20
          bclr      #4,d5
setb20    btst      d1,(a1)+            ; 20: Pin28 6V
            beq.s   setb21
          moveq     #$3C,d3
          bset      #5,d5
setb21
setb22
          move.b    d5,readbuff+$40(a6) ; Steuerbyte
          move.b    d4,readbuff+$42(a6) ; 3FC6    12/16V
          move.b    d3,readbuff+$43(a6) ; 3FC7    Ein/Aus
          rts
; ------------------------------------------------------
; Texte + Meldungen + Aufruf Menu's
          include   flp1_eprommer_d_txt           ; deutsch
;          include   flp1_eprommer_e_txt           ; englisch
; ------------------------------------------------------
xodef     dc.w      $0200               ; wd_xorg
yodef     dc.w      $000C               ; wd_yorg

fendef    dc.b      0                   ; 0 voreingestellt / -1 Zeiger
          dc.b      0
          dc.b      'EPROMMER II Ende'

          end
